import zipfile
import xml.dom.minidom
import xml.sax
from xml.dom.minidom import Document
from ImportExport import Counter, DataTable, to_utf8, Exporter, Dump

class Kirjutus:
    def __init__(self, ivajuur, kursusenr):
        """Uue eksportkirjutaja loomine. Parameetrina eksporditava iva juurobjekt"""
        # Paisktabel failandmete hoidmiseks
        self.binarydata = DataTable()
        self.idmap = {}
        self.dom=Document()
        self.loendur=Counter()
#        self.juur=self.dom.createElement("manifest")
#        self.dom.appendChild(self.juur)
#        self.juur.appendChild(self.dom.createElement("metadata"))
#        self.orgd=self.dom.createElement("organizations")
#        self.juur.appendChild(self.orgd)
#        self.orgn=self.dom.createElement("organization")
#        self.orgd.appendChild(self.orgn)
        self.iva=ivajuur
        self.kursusenr=kursusenr
#        print "nr "+str(kursusenr)
        self.kursus=getattr(ivajuur.courses, str(kursusenr))
        self.juur=self.kirjutaManifest(self.dom, "kursuse pealkiri")
#        self.kirjutaOsad()
        
    def kirjutaManifest(self, alus, pealkiri=""):
        "Manifesti ploki loomine"
        m=self.dom.createElement("manifest")
	m.setAttribute('identifier','IVA')
	m.setAttribute('version','1.1')
	m.setAttribute('xmlns','http://www.imsproject.org/xsd/ims_cp_rootv1p1')
	m.setAttribute('xmlns:imsmd','http://www.imsproject.org/xsd/ims_md_rootv1p1')
	m.setAttribute('xmlns:xsi','http://www.w3.org/2000/10/XMLSchema-instance')
	m.setAttribute('xsi:schemaLocation','http://www.imsproject.org/xsd/ims_cp_rootv1p1 http://www.imsproject.org/xsd/ims_cp_rootv1p1.xsd http://www.imsproject.org/xsd/ims_md_rootv1p1 http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd')
        md=self.dom.createElement("metadata")
        m.appendChild(md)

	mds=self.dom.createElement('schema')
	md.appendChild(mds)
	text = self.dom.createTextNode('IMS Content')
	mds.appendChild(text)

	mdv=self.dom.createElement('schemaversion')
	md.appendChild(mdv)
	mdv.appendChild(self.dom.createTextNode('1.1'))

	self.rekord(md, self.kursus.get_name(),self.kursus.get_description())

        #t=self.dom.createElement("title")
        #md.appendChild(t)
        #t.appendChild(self.dom.createTextNode(pealkiri))

        orgnz=self.dom.createElement("organizations")
        m.appendChild(orgnz)

	#bcd = self.kirjutaToo(orgnz, "Raamaturiiul")
	#abc = self.kirjutaRaamatustrukt(bcd)
	#bcd.appendChild(abc)
	bcd = self.kirjutaToo(orgnz, "Raamaturiiul")
        self.kirjutaRaamatustrukt(bcd)
	
	self.kirjutaToo(orgnz, "Teadmuspaja")
	self.kirjutaToo(orgnz, "Meediapaja")
	self.kirjutaToo(orgnz, "Wiki")
	self.kirjutaToo(orgnz, "QT")

        m.appendChild(self.dom.createElement("resources"))

	self.tooManifest(m,'riiul')
	self.tooManifest(m,'teadmuspaja')

        alus.appendChild(m)
        return m

    def tooManifest(self, vanem, kes=''):
	""" Kirjuta t66riista manifest ja resursid"""
	rek = self.dom.createElement('manifest')
	rek.setAttribute('identifier',kes+self.kursusenr)
	rek.setAttribute('version','1.1')
#	rek.setAttribute('xml:base',kes+self.kursusenr+'/')
	orgz = self.dom.createElement('organizations')
	rek.appendChild(orgz)
	org = self.kirjutaToo(orgz,kes+self.kursusenr)
	itemid = self.kirjutaRaamatustrukt(org)
	# manifesti kylge resource
	resurss = self.kirjutaResurss(rek)
	vanem.appendChild(rek)
	return rek

    def kirjutaResurss(self, vanem):
	""" Kirjutab ressursid raamaturiiulist """
	rek = self.dom.createElement('resources')
        #self.riiulidokument=Document()
        #riiul=self.riiulidokument.createElement("raamaturiiul")
        #self.riiulidokument.appendChild(riiul)
        ex=Exporter(self.iva)
        ex.binarydata=self.binarydata
          #et lheks samasse hoidlass
        ex.exportWebtopFolderitemid(self.kursus.gf, rek)
        #d=Dump()
        #alus.writexml(d)
	vanem.appendChild(rek)
	return rek

    def kirjutaToo(self, vanem, kes=''):
	"kirjutab organisatsiooni" 
	rek = self.dom.createElement('organization')
	rek.setAttribute('identifier','IVA')	
	rek.setAttribute('structure','hierarchical')

	tit = self.dom.createElement('title')
	tit.appendChild(self.dom.createTextNode(kes))
	rek.appendChild(tit)

	md = self.dom.createElement('metadata')
	rek.appendChild(md)
	self.rekord(md, kes, "kirjeldus")
	vanem.appendChild(rek)	
	return rek

    def rekord(self, vanem, tiitel='tiitel', desk_str='kirjeldus'):
	"lisab imsmd recordi"
	rek = self.dom.createElement('imsmd:record')
	gen = self.dom.createElement('imsmd:general')
	rek.appendChild(gen)
	tit = self.dom.createElement('imsmd:title')
	gen.appendChild(tit)
	lang = self.dom.createElement('imsmd:langstring')
	lang.setAttribute('xml:lang','en-US')
	lang.appendChild(self.dom.createTextNode(tiitel))
	tit.appendChild(lang)

	desk = self.dom.createElement('imsmd:description')
	desclang = self.dom.createElement('imsmd:langstring')
	desclang.setAttribute('xml:lang','en-US')
	desclang.appendChild(self.dom.createTextNode(desk_str))
	desk.appendChild(desclang)
	gen.appendChild(desk)

	keele = self.dom.createElement('imsmd:language')
	keele.appendChild(self.dom.createTextNode('en_US'))
	gen.appendChild(keele)
	
	vanem.appendChild(rek)
	return rek

    def lisaElement(self, manifest, elemendipealkiri):
        "Lisab manifesti elemendi"
        element=self.dom.createElement("item")        
        manifest.getElementsByTagName("organizations")[0].\
          getElementsByTagName("organization")[0].appendChild(element)
        pealkiri=self.dom.createElement("title")
        element.appendChild(pealkiri)
        pealkiri.appendChild(self.dom.createTextNode(elemendipealkiri))
        return element
        
        
    def lisaRessurss(self, manifest):
        "Lisab manifesti ressursi"
        ressurss=self.dom.createElement("resource")
        manifest.getElementsByTagName("resources")[0].appendChild(ressurss)
        return ressurss
        
#    def kirjutaOsad(self):
#       "kirjutab organisatsioonid vastavate alamprogrammide abil - nii manifesti kui kirje organisatsiooni juurde"
#       self.kirjutaRaamaturiiul()
       
       
#    def kirjutaOsa(self, nimetus):
#       "Kirjutab he organisatsiooni ja vljastab selle id"
#       nr=self.loendur.get_next_counter()
#       tekst="COURSE_"+str(nr)
#       itm=self.dom.createElement("item")
#       itm.setAttribute("identifier", tekst)
#       pealkiri=self.dom.createElement("title")
#       pealkiri.appendChild(self.dom.createTextNode(nimetus))
#       itm.appendChild(pealkiri)
#       self.orgn.appendChild(itm)
#       return tekst
       
    def kirjutaRaamatustrukt(self, vanem):
	"kirjutab raamaturiiuli struktuuri"
	riiul=self.dom.createElement("item")
	riiul.setAttribute('identifier','riiul'+self.kursusenr)
	riiul.setAttribute('structure','hierarchical')
	riiul.setAttribute('identifierref','riiul'+self.kursusenr)
	riiul.setAttribute('isvisible','true')
	ex=Exporter(self.iva)
	ex.binarydata=self.binarydata
	ex.exportWebtopFolderStructure(self.kursus.gf, riiul)
	vanem.appendChild(riiul)
	return riiul 
       
    def kirjutaRaamaturiiul(self):
        "Lisab vljundpuusse kursuse raamaturiiuli sisu"
        #rm=self.kirjutaManifest(self.juur, "raamaturiiul")
        rm=self.dom.createElement("raamaturiiul")
	rm.setAttribute("identifier","ivariiul")
        #self.lisaElement(rm, "riiulisisu")
        #r=self.lisaRessurss(rm)
        f=self.dom.createElement("file")
        rm.appendChild(f)
        f.setAttribute("href", "ivariiul.xml")
        self.kirjutaRaamaturiiuliSisu()
        
    def kirjutaRaamaturiiuliSisu(self):
        "Kirjutab raamaturiiuli sisu omaette faili"
        self.riiulidokument=Document()
        riiul=self.riiulidokument.createElement("raamaturiiul")
        self.riiulidokument.appendChild(riiul)
        ex=Exporter(self.iva)
        ex.binarydata=self.binarydata 
          #et lheks samasse hoidlasse
        ex.exportWebtopFolderContents(self.kursus.gf, riiul)
        #d=Dump()
        #alus.writexml(d)
        
    
        
    def kirjutaTestid(self):
        "Lisab vljundpuusse kursusel olevate testide lesanded"


    def pakiTulemusFaili(self, failinimi="ivaarhiiv.zip"):
        "Olemasolevate tkkide phjal luuakse zip-fail"        
        zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        dump = Dump()
        self.dom.writexml(dump)
        zip.writestr(zipfile.ZipInfo("ivamanifest.xml"),dump.getdata())
        #dump = Dump()
        #self.riiulidokument.writexml(dump)
        #zip.writestr(zipfile.ZipInfo("riiul"+self.kursusenr+"/imsmanifest.xml"),dump.getdata())
        print "Riiul failis"
        for name in self.binarydata.getNames():
            zip.writestr(
                zipfile.ZipInfo(name),
                str(self.binarydata.getData(name)))
        zip.close()
