import AccessControl
import OFS, Globals
from OFS import SimpleItem
import types
import time
from TraversableWrapper import Traversable
from Globals import Persistent
from AccessControl import ClassSecurityInfo
from Cruft import Cruft
from common import add_dtml

class KalendriSyndmus(
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
     "Teade kalendris"
     def __init__(self, nimi, lyhi='', pikk='', algus=time.time(), lopp=time.time(), viide="", siseviide="", olek=0):
       "Alustus"
       self.nimi=nimi
       self.lyhi=lyhi
       self.pikk=pikk
       self.algus=algus
       self.lopp=lopp
       self.viide=viide
       self.siseviide=siseviide
       self.olek=olek #0-ajatu sndmus 1-lpetamata t 2-lpetatud t
       
     def kysiNimi(self):
       "Teate nimi"
       return self.nimi
       
     def kysiLyhi(self):
       "Lhikirjeldus"
       return self.lyhi
       
     def kysiPikk(self):
       "Pikk kirjeldus"
       return self.pikk
       
     def kysiAlgus(self):
       "Syndmuse algusaeg"
       return self.algus
       
     def kysiLopp(self):
       "Syndmuse lppaeg"
       return self.lopp
       
     def aegTekstina(self, REQUEST, aeg):
       "tekstiesitus"
       self.get_lang(('common',), REQUEST)
       if aeg==-1: return "*"
       return time.strftime(REQUEST['L_timestamp_format'], time.localtime(aeg))

     def tekstAjana(self, REQUEST, ajatekst):
       "Tagasi ajaformaati"
       self.get_lang(('common',), REQUEST)
       return mktime(time.strptime(REQUEST['L_timestamp_format']), ajatekst)

       
     def kysiViide(self):
       "Vlisviide"
       return self.viide
       
     def kysiSiseviide(self):
       "Siseviide"
       return self.siseviide
       
     def kysiSiseviiteURL(self):
       "Siseviide"
       return self.fle_root().absolute_url()+self.siseviide
       
     def siseviiteNimi(self):
       "Nagu funktsiooni nime tleb"
       if self.siseviide=="": return ""
       m=self.siseviide.split("/")
       o=self.fle_root()
      # try:
       for x in m:
         if len(x)>0:
          o=getattr(o, x)
      # except:
      #   return "Kadunud"
       return o.get_name()
       #return getattr(self.fle_root(), self.siseviide)
       #return str(self.get_object_of_url(self.siseviide, self.fle_root()))
       
     def kysiSiseviiteLink(self):
       "Koos"
       return "<a href='"+self.kysiSiseviiteURL()+"'>"+self.siseviiteNimi()+"</a>"
       
     def kysiOlek(self):
       "Sndmuse olek"
       if hasattr(self, 'olek'): return self.olek
       return 0
       
     def olekuTekst(self, REQUEST, nr=-1):
       "Olek tekstina"
       if nr==-1: nr=self.kysiOlek()
       if nr==0: return ""
       if nr==1: return "pooleli"
       if nr==2: return "valmis"
       
     def olekuLahter(self, REQUEST):
       "Olekut illustreeriv lahter"
       if self.kysiOlek()==0:
         return "<td>&nbsp;</td>"
       if self.kysiOlek()==1: #pooleli
         if time.time()>self.lopp: #Hilinenud
           return "<td bgcolor='red'>&nbsp;</td>"
         else: return   "<td bgcolor='blue'>&nbsp;</td>"
       return  "<td bgcolor='green'>&nbsp;</td>"       
       
     def olekuVarv(self, REQUEST):
       "Olekut illustreeriv lahter"
       if self.kysiOlek()==0:
         return "black"
       if self.kysiOlek()==1: #pooleli
         if time.time()>self.lopp: #Hilinenud
           return "red"
         else: return   "blue"
       return  "green"       
       
       
     def tabeliRida(self, REQUEST):
       "Osa tabelist"
       tulemus="<tr>"+\
         self._tabeliReaSisu(REQUEST)+"</tr>\n"
       return tulemus

     def muutmisTabeliRida(self, REQUEST):
       "Osa tabelist"
       tulemus="<tr><td><input type='checkbox' name='kustutus' value='"+str(self.id)+"'/></td>"+\
         self._tabeliReaSisu(REQUEST)+"</tr>\n"
       return tulemus
       
     def paevikuTabeliRida(self, REQUEST):
       "Avalehe pevikusse"
       tulemus="<tr>"+self._tabeliReaSisu(REQUEST)+"</tr>\n"
       return tulemus
       
     def _tabeliReaSisu(self, REQUEST):
       "Abitkk teistele"
       tulemus= "<td>"+self.asukohtTekstina(REQUEST)+"</td><td><font color='"+self.olekuVarv(REQUEST)+"'>"+\
              self.aegTekstina(REQUEST, self.kysiAlgus())+\
              "</font></td><td><a href='"+self.absolute_url()+"'>"+\
              self.kysiNimi()+"</a></td><td>"
       if self.kysiOmanik().getUserName()==REQUEST.AUTHENTICATED_USER.getUserName():
         tulemus=tulemus+self.kysiLyhi()
       else:
         tulemus=tulemus+self.kysiLyhi()+" dd"
       tulemus=tulemus+"</td>"       
       return tulemus
            
     def asukohaNimi(self):
       "Kursuse nimi, kus sndmus asub, muu sndmuse puhul None"
       aadress=self.absolute_url()
       algus=aadress.find('courses')
       if algus>=0:
         nr=aadress[algus:].split("/")[1]
         return getattr(self.fle_root().courses, nr).get_name()
       return None
       
     def asukohtTekstina(self, REQUEST):
       "Snastatuna tabelisse kandmiseks"
       t=self.asukohaNimi()
       if t is None:
         if REQUEST.AUTHENTICATED_USER==self.kysiOmanik(): 
           return "Oma"
         else:
           return self.kysiOmanik().getUserName()
       return t+" / " + self.kysiOmanik().getUserName()
            
       
     def kysiOmanik(self):
       "Sndmuse looja"
       return self.getOwner()

     def kasOmanik(self, REQUEST):
       "jah/ei"
       return REQUEST.AUTHENTICATED_USER==self.kysiOmanik()
       
     def index_html(self, REQUEST):
       "Vljanitus"
       tulemus=self.hdr(self, REQUEST)
       tulemus=tulemus+"</p>\n<form action=\"muutmisVorm\">"
       tulemus=tulemus+"<table border=\"0\" cellpadding=\"2\" cellspacing=\"1\" bgcolor=\"#EEEEEE\">\n"
       tulemus=tulemus+"<tr><th colspan=\"2\">"+self.kysiNimi()+"</th></tr>\n"
       tulemus=tulemus+"<tr><td class=\"t1\">Lhikirjeldus</td><td class=\"t1\">"+self.kysiLyhi()+"</td></tr>\n"      
       tulemus=tulemus+"<tr><td class=\"t1\">Pikk kirjeldus</td><td class=\"t1\">"+self.kysiPikk()+"</td></tr>\n"      
       tulemus=tulemus+"<tr><td class=\"t1\">Algusaeg</td><td class=\"t1\">"+self.aegTekstina(REQUEST, self.kysiAlgus())+"</td></tr>\n"      
       if self.kysiAlgus()!=self.kysiLopp():       
         tulemus=tulemus+"<tr><td class=\"t1\">Lpp</td><td class=\"t1\">"+self.aegTekstina(REQUEST, self.kysiLopp())+"</td></tr>\n"      
       if self.kysiViide()!="":
         tulemus=tulemus+"<tr><td class=\"t1\">Viide</td><td class=\"t1\"><a href='"+self.kysiViide()+"'>"+self.kysiViide()+"</a></td></tr>\n"      
       if self.kysiSiseviide()!="":
         tulemus=tulemus+"<tr><td class=\"t1\">Siseviide</td><td class=\"t1\">"+self.kysiSiseviiteLink()+"</td></tr>\n"      
       if self.kysiOlek():
         tulemus=tulemus+"<tr><td class=\"t1\">Olek</td><td class=\"t1\">"+self.olekuTekst(REQUEST)+"</td></tr>" 
       if self.kasOmanik(REQUEST):
        tulemus=tulemus+"<tr><td colspan=\"2\"><input type=\"submit\" value=\"Muuda\" /></td></tr>"
       tulemus=tulemus+"</table>\n</form>\n"
       tulemus=tulemus+self.fle_html_footer(self, REQUEST)
       return tulemus
         
     def muutmisVorm(self, REQUEST):
       "Sndmuse muutmine"
       import YlTest
       from YlTest import LahendusLuba
       abi=LahendusLuba() #vaid ajamen tarbeks
       self.get_lang(('ivatests',), REQUEST)
       tulemus=self.hdr(self, REQUEST)
       tulemus=tulemus+"</p>\n<form action=\"muutmisLeht\">\n"
       tulemus=tulemus+"<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\">\n"
       tulemus=tulemus+"<tr><td>Nimi</td><td><input type=\"text\" name=\"nimi\" value=\""+self.kysiNimi()+"\" /></td></tr>\n"
       tulemus=tulemus+"<tr><td>Lhikirjeldus</td><td><input type=\"text\" name=\"lyhi\" value=\""+self.kysiLyhi()+"\" /></td></tr>\n"
       tulemus=tulemus+"<tr><td>Pikk kirjeldus</td><td><textarea name=\"pikk\">"+self.kysiPikk()+"</textarea></td></tr>\n"             
       tulemus=tulemus+"<tr><td>Algusaeg</td><td>"+abi.ajaMuutmisElemendid("algus", self.kysiAlgus())+"</td></tr>\n"      
       tulemus=tulemus+"<tr><td>Lppaeg</td><td>"+abi.ajaMuutmisElemendid("lopp", self.kysiLopp())+"</td></tr>\n"      
       tulemus=tulemus+"<tr><td>Viide</td><td><input type=\"text\" name=\"viide\" value=\""+self.kysiViide()+"\" /></td></tr>\n"
       tulemus=tulemus+"<tr><td>Siseviide</td><td><input type=\"text\" name=\"siseviide\" value=\""+self.kysiSiseviide()+"\" /></td></tr>\n"      
       tulemus=tulemus+"<tr><td>Olek</td><td><select name=\"olek\">"
       for i in range(3):
         tulemus=tulemus+"<option value=\""+str(i)+"\" "
         if i==self.kysiOlek():
           tulemus=tulemus+" selected=\"selected\" "
         tulemus=tulemus+">"+self.olekuTekst(REQUEST, nr=i)+"</option>"
       tulemus=tulemus+"</select></td></tr>"
       tulemus=tulemus+"</table><input type=\"submit\" value=\"Salvesta\" />"
       tulemus=tulemus+self.fle_html_footer(self, REQUEST)
       return tulemus
       
     def muutmisLeht(self, REQUEST):
       "Sndmuse muutus"
       import YlTest
       from YlTest import LahendusLuba
       abi=LahendusLuba() #vaid ajamen tarbeks
       self.algus=abi.ajaPyydmisLeht(REQUEST, "algus")
       self.lopp=abi.ajaPyydmisLeht(REQUEST, "lopp")
       if self.lopp<self.algus: self.lopp=self.algus
       self.nimi=REQUEST['nimi']
       self.lyhi=REQUEST['lyhi']
       self.pikk=REQUEST['pikk']
       self.viide=REQUEST['viide']
       self.siseviide=REQUEST['siseviide']
       self.olek=int(REQUEST['olek'])
       REQUEST.RESPONSE.redirect('index_html')
       
     def kasSyndmusPaeval(self, aasta, kuu, paev):
       "jah/ei"
       algusm=time.localtime(self.algus)
       algusmp=time.mktime((algusm[0], algusm[1], algusm[2], 0, 0, 0, 0, 0, 0))
       loppm=time.localtime(self.lopp)
       loppmp=time.mktime((loppm[0], loppm[1], loppm[2]+1, 0, 0, 0, 0, 0, 0))
       aegmp=time.mktime((aasta, kuu, paev, 0, 0, 0, 0, 0, 0))
       if aegmp>=algusmp and aegmp<loppmp:return 1
       return 0
       
     def kasLubatudParandada(self, REQUEST):
       "Muutmisigus"
       if 'Owner' in get_local_roles(self,uname):
           return 1
       if 'Teacher' in get_roles(self,uname):
           return 1
       return 0
       
class KalendriSyndmusteKataloog(
     OFS.Folder.Folder,
     OFS.SimpleItem.Item,
     Persistent,
     AccessControl.Role.RoleManager,
     Traversable,
     Cruft
     ):
     
     syndmuseNr=0
     
     def kysiUusNr(self):
       self.syndmuseNr=self.syndmuseNr+1
       return self.syndmuseNr
     
     def syndmusteTabel(self, REQUEST):
       "Kataloogis olevad sndmused"
       loetelu=self.objectValues()
       tulemus=self.hdr(self, REQUEST)+"<table>"
       for syndmus in loetelu:
         tulemus=tulemus+syndmus.tabeliRida(REQUEST)
       tulemus=tulemus+"</table>"+self.fle_html_footer(self,REQUEST)
       return tulemus
       
     def index_html(self, REQUEST):
       "tabel"
       return self.syndmusteTabel(REQUEST)
       
     def syndmusteMuutmisVorm(self, REQUEST):
       "Kataloogis olevad sndmused"
       loetelu=self.objectValues()
       tulemus=self.hdr(self, REQUEST)+"<br />"
       tulemus=tulemus+"<a href='lisaSyndmus'>Lisa syndmus</a>"
       tulemus=tulemus+"<form action='syndmusteMuutmisLeht'><table>"
       for syndmus in loetelu:
         tulemus=tulemus+syndmus.muutmisTabeliRida(REQUEST)
       tulemus=tulemus+"</table><input type='submit' value='Kustuta' /></form>"
       tulemus=tulemus+self.fle_html_footer(self, REQUEST)
       return tulemus
       
     def syndmusteMuutmisLeht(self, REQUEST, kustutus=()):
       "Sndmuste kustutamine"
       if type(kustutus)==types.StringType:
         kustutus=(kustutus,)
       for x in kustutus:
         self._delObject(x)
       REQUEST.RESPONSE.redirect('syndmusteMuutmisVorm')
       
     def lisaSyndmus(self, REQUEST):
       "Uus sndmus"
       nr=str(self.kysiUusNr())
       k=KalendriSyndmus(nr)
       k.id=nr
       self._setObject(nr, k)
       REQUEST.RESPONSE.redirect(nr+"/muutmisVorm")
       
