import zipfile
import xml.dom.minidom
import xml.sax
from xml.dom.minidom import Document
from ImportExport import Counter, DataTable, to_utf8, Exporter, Dump

class Kirjutus:
    def __init__(self, ivajuur, kursusenr):
        """Uue eksportkirjutaja loomine. Parameetrina eksporditava iva juurobjekt"""
        # Paisktabel failandmete hoidmiseks
        self.binarydata = DataTable()
        self.idmap = {}
        self.dom=Document()
        self.loendur=Counter()
#        self.juur=self.dom.createElement("manifest")
#        self.dom.appendChild(self.juur)
#        self.juur.appendChild(self.dom.createElement("metadata"))
#        self.orgd=self.dom.createElement("organizations")
#        self.juur.appendChild(self.orgd)
#        self.orgn=self.dom.createElement("organization")
#        self.orgd.appendChild(self.orgn)
        self.iva=ivajuur
        self.kursusenr=kursusenr
#        print "nr "+str(kursusenr)
        self.kursus=getattr(ivajuur.courses, str(kursusenr))
        self.juur=self.kirjutaManifest(self.dom, "kursuse pealkiri")
#        self.kirjutaOsad()
        
    def kirjutaManifest(self, alus, pealkiri=""):
        "Manifesti ploki loomine"
        m=self.dom.createElement("manifest")
	m.setAttribute('identifier','IVA')
	m.setAttribute('version','1.1')
	m.setAttribute('xmlns','http://www.imsproject.org/xsd/ims_cp_rootv1p1')
	m.setAttribute('xmlns:imsmd','http://www.imsproject.org/xsd/ims_md_rootv1p1')
	m.setAttribute('xmlns:xsi','http://www.w3.org/2000/10/XMLSchema-instance')
	m.setAttribute('xsi:schemaLocation','http://www.imsproject.org/xsd/ims_cp_rootv1p1 http://www.imsproject.org/xsd/ims_cp_rootv1p1.xsd http://www.imsproject.org/xsd/ims_md_rootv1p1 http://www.imsproject.org/xsd/ims_md_rootv1p1.xsd')
        md=self.dom.createElement("metadata")
        m.appendChild(md)

	mds=self.dom.createElement('schema')
	md.appendChild(mds)
	text = self.dom.createTextNode('IMS Content')
	mds.appendChild(text)

	mdv=self.dom.createElement('schemaversion')
	md.appendChild(mdv)
	mdv.appendChild(self.dom.createTextNode('1.1'))

	self.rekord(md, self.kursus.get_name(),self.kursus.get_description())

        #t=self.dom.createElement("title")
        #md.appendChild(t)
        #t.appendChild(self.dom.createTextNode(pealkiri))

        orgnz=self.dom.createElement("organizations")
        m.appendChild(orgnz)

	#bcd = self.kirjutaToo(orgnz, "Raamaturiiul")
	#abc = self.kirjutaRaamatustrukt(bcd)
	#bcd.appendChild(abc)
	bcd = self.kirjutaToo(orgnz, "Raamaturiiul")
        self.kirjutaRaamatustrukt(bcd)
	
	self.kirjutaToo(orgnz, "Teadmuspaja")
	self.kirjutaToo(orgnz, "Meediapaja")
	self.kirjutaToo(orgnz, "Wiki")
	self.kirjutaToo(orgnz, "QT")

        m.appendChild(self.dom.createElement("resources"))

	self.tooManifest(m,'bookshelf','riiul')
	self.tooManifest(m,'teadmuspaja','teadmuspaja')
	self.tooManifest(m,'meedia','meediapaja')
	self.tooManifest(m,'QT','QT')

        alus.appendChild(m)
        return m

    def kirjutaTPajaRes(self, vanem):
	tulem = self.dom.createElement('resources')
	for ctx in self.kursus.get_children("CourseContext"):
		rek = self.dom.createElement('teadmuspaja')
		tulem.appendChild(rek)	
		id = self.dom.createElement('id')
		id.appendChild(self.dom.createTextNode(ctx.get_id()))
		rek.appendChild(id)
		elem = self.dom.createElement('title')
		elem.appendChild(self.dom.createTextNode(ctx.get_name()))
		rek.appendChild(elem)
		elem2 = self.dom.createElement('lkirjeldus')
		elem2.appendChild(self.dom.createTextNode(ctx.get_description()))
		rek.appendChild(elem2)
                elem3 = self.dom.createElement('pkirjeldus')
                elem3.appendChild(self.dom.createTextNode(ctx.get_long_description()))
		rek.appendChild(elem3)
		rek.appendChild(self.exportTTS(ctx.get_thinking_type_set()))

        	frag = self.dom.createDocumentFragment()

        	for note in ctx.get_children('Note'):
        	    self.exportNote(frag,note)

		rek.appendChild(frag)

        vanem.appendChild(tulem)
        return tulem

    def exportNote(self,frag,note):
        """Exports the given note."""
        newElem = self.dom.createElement
        newText = self.dom.createTextNode

        elem = newElem("thread-topic")
        elem.setAttribute("id",note.get_id())
        elem2 = newElem("metadata")
        elem3 = newElem("title")
        elem3.appendChild(newText(note.get_real_subject()))
        elem2.appendChild(elem3)
        elem3 = newElem("creator")
        elem3.appendChild(newText(note.get_author()))
        elem2.appendChild(elem3)

        elem3 = newElem("extra-meta")
        elem4 = newElem("meta")
        elem4.setAttribute("base","FLE3")
        elem4.setAttribute("description","metatype")
        elem5 = newElem("unstructured-source")
        elem5.appendChild(newText("Note"))
        elem4.appendChild(elem5)
        elem3.appendChild(elem4)
        elem4 = newElem("meta")
        elem4.setAttribute("base","FLE3")
        elem4.setAttribute("description","parent")
        elem5 = newElem("unstructured-source")
        elem5.appendChild(newText(note.parent().get_id()))
        elem4.appendChild(elem5)
        elem3.appendChild(elem4)
        elem4 = newElem("meta")
        elem4.setAttribute("base","FLE3")
        elem4.setAttribute("description","type")
        elem5 = newElem("unstructured-source")
        elem5.appendChild(newText(note.get_tt_id()))
        elem4.appendChild(elem5)
        elem3.appendChild(elem4)
        elem2.appendChild(elem3)
        elem.appendChild(elem2)

        elem2 = newElem("source")
        elem3 = newElem("p")
        elem3.appendChild(newText(note.get_body()))
        elem2.appendChild(elem3)

        if note.get_url()!='':
            elem3 = newElem("internet-source")
            elem3.setAttribute("url",note.get_url())
            elem3.setAttribute("link-name",note.get_url_name())
            elem2.appendChild(elem3)

        if note.has_image():
            name = self.binarydata.storeData(
                note.get_image_data())
            elem3 = newElem("figure")
            elem4 = newElem("figure-source")
            elem4.setAttribute("entity",name)
            elem3.appendChild(elem4)
            elem4 = newElem("figure-text")
            elem5 = newElem("p")
            elem5.appendChild(newText(note.get_image_name()))
            elem4.appendChild(elem5)
            elem3.appendChild(elem4)
            elem2.appendChild(elem3)

        elem.appendChild(elem2)

        frag.appendChild(elem)

        for reply in note.get_children('Note'):
            self.exportNote(frag,reply)


    def exportTTS(self,set):
        """Exports the given knowledgetypeset."""
	"""  Siit saame teadmustyybistiku nime """
        newElem = self.dom.createElement
        newText = self.dom.createTextNode

        elem = newElem("knowledge-object")
        elem.appendChild(newText(set.get_name()))

        return elem

    def kirjutaMPajaRes(self, vanem):
          #et lheks samasse hoidlass
        #tulem = ex.exportJamming(self.kursus)
        ex=Exporter(self.iva)
        ex.binarydata=self.binarydata
	tulem = self.dom.createElement('Jamming')
        for js in self.kursus.get_child('jamming').get_children('JamSession'):
	    elem = self.dom.createElement("JamSession")
	    elem.setAttribute('CourseName', self.kursus.get_name())
	    elem.setAttribute('Name', js.get_name())
	    elem.setAttribute('Type', js.get_type())
	    elem.setAttribute('Descr', js.get_description())
	    elem.setAttribute('ID', js.get_id())
	    tulem.appendChild(elem)

	    first = js.get_starting_artefact_id()
	    for ja in js.get_children('JamArtefact'):
		if ja.get_id() == first:
			art = self.dom.createElement('Artefact')
			art.setAttribute('Name', ja.get_real_name())
			art.setAttribute('Author', str(ja.get_author()))
			art.setAttribute('ID', ja.get_id())

			annotations = self.dom.createElement('Annotations')
			for tple in ja.get_real_annotations():
				try:
					(uname, a_time, a_text, censored, censorer) = tple
				except ValueError:
					(uname, a_time, a_text) = tple
					censored=0
					censorer=''
				a_elem = self.dom.createElement('Annotation')
				a_elem.setAttribute('Author', uname)
				a_elem.setAttribute('Date', repr(a_time))
				text = self.dom.createElement('Text')
				text.appendChild(self.dom.createTextNode(a_text))
				a_elem.appendChild(text)
				annotations.appendChild(a_elem)
				art.appendChild(annotations)

				name = self.binarydata.storeData(ja.get_real_data())
				link = self.dom.createElement('DataLink')
				link.setAttribute('LocalName', name)
				link.setAttribute('ContentType', ja.get_content_type())
				art.appendChild(link)

			tulem.appendChild(art)
	     
	    #elem2 = self.dom.createElement('JamArtefact')
	    #elem2.setAttribute('Name', js.get_real_name())
	    #elem2.setAttribute('Author', str(ja.get_author()))
	    #elem2.setAttribute('ID', ja.get_id())
	    #elem.appendChild(elem2)

        vanem.appendChild(tulem)

        return tulem

    def kirjutaTest(self, vanem):
	tulem = self.dom.createElement('questestinterop')
	komment = self.dom.createElement('qticomment')
	komment.appendChild(self.dom.createTextNode('Here is a set of questions and tests from IVA'))
	tulem.appendChild(komment)
	for hoidla in self.kursus.testid.objectValues():
	  #print hoidla.get_id()
	  print "-----"
	  for yled in hoidla.objectValues():
		#print "->>"+yled.get_id()
		tyyp = yled.meta_type
        	if tyyp=='ValikYlesanne':
			print yled.get_id() +" -- "+ tyyp
			pass
        	if tyyp=='TekstivastusegaYlesanne':
			print yled.get_id() +" -- "+ tyyp
			pass
        	if tyyp=='YksikvalikYlesanne':
			print yled.get_id() +" -- "+ tyyp
			pass
        	if tyyp=='OigeTekstivastusegaYlesanne':
			print yled.get_id() +" -- "+ tyyp
			pass
        	if tyyp=='MitmikvalikYlesanne':
			print yled.get_id() +" -- "+ tyyp
			pass
        	if tyyp=='ArvuvahemikuliseVastusegaYlesanne':
			print yled.get_id() +" -- "+ tyyp
			pass
        	if tyyp=='ProtsentYlesanne':
			print yled.get_id() +" -- "+ tyyp
			pass
        	if tyyp=='VastavusYlesanne':
			print yled.get_id() +" -- "+ tyyp
			pass
			#vastav = self.dom.createElement('vastavusylesanne')
			#print yled.normPunktid
			#tulem.appendChild(vastav)

	vanem.appendChild(tulem)
	return tulem

    def tooManifest(self, vanem, mida='bookshelf', kes=''):
	""" Kirjuta t66riista manifest ja resursid"""
	rek = self.dom.createElement('manifest')
	rek.setAttribute('identifier',kes+self.kursusenr)
	rek.setAttribute('version','1.1')
#	rek.setAttribute('xml:base',kes+self.kursusenr+'/')
	orgz = self.dom.createElement('organizations')
	rek.appendChild(orgz)
	org = self.kirjutaToo(orgz,kes+self.kursusenr)
	if mida == 'bookshelf':
		itemid = self.kirjutaRaamatustrukt(org)
	# manifesti kylge resource
	if mida == 'bookshelf':
		resurss = self.kirjutaResurss(rek)
	if mida == 'teadmuspaja':
		tpaja = self.kirjutaTPajaRes(rek)
	if mida == 'meedia':
		mpaja = self.kirjutaMPajaRes(rek)
	if mida == 'QT':
		qt = self.kirjutaTest(rek)
	vanem.appendChild(rek)
	return rek

    def kirjutaResurss(self, vanem):
	""" Kirjutab ressursid raamaturiiulist """
	rek = self.dom.createElement('resources')
        #self.riiulidokument=Document()
        #riiul=self.riiulidokument.createElement("raamaturiiul")
        #self.riiulidokument.appendChild(riiul)
        ex=Exporter(self.iva)
        ex.binarydata=self.binarydata
          #et lheks samasse hoidlass
        ex.exportWebtopFolderitemid(self.kursus.gf, rek)
        #d=Dump()
        #alus.writexml(d)
	vanem.appendChild(rek)
	return rek

    def kirjutaToo(self, vanem, kes=''):
	"kirjutab organisatsiooni" 
	rek = self.dom.createElement('organization')
	rek.setAttribute('identifier','IVA')	
	rek.setAttribute('structure','hierarchical')

	tit = self.dom.createElement('title')
	tit.appendChild(self.dom.createTextNode(kes))
	rek.appendChild(tit)

	md = self.dom.createElement('metadata')
	rek.appendChild(md)
	self.rekord(md, kes, "kirjeldus")
	vanem.appendChild(rek)	
	return rek

    def rekord(self, vanem, tiitel='tiitel', desk_str='kirjeldus'):
	"lisab imsmd recordi"
	rek = self.dom.createElement('imsmd:record')
	gen = self.dom.createElement('imsmd:general')
	rek.appendChild(gen)
	tit = self.dom.createElement('imsmd:title')
	gen.appendChild(tit)
	lang = self.dom.createElement('imsmd:langstring')
	lang.setAttribute('xml:lang','en-US')
	lang.appendChild(self.dom.createTextNode(tiitel))
	tit.appendChild(lang)

	desk = self.dom.createElement('imsmd:description')
	desclang = self.dom.createElement('imsmd:langstring')
	desclang.setAttribute('xml:lang','en-US')
	desclang.appendChild(self.dom.createTextNode(desk_str))
	desk.appendChild(desclang)
	gen.appendChild(desk)

	keele = self.dom.createElement('imsmd:language')
	keele.appendChild(self.dom.createTextNode('en_US'))
	gen.appendChild(keele)
	
	vanem.appendChild(rek)
	return rek

    def lisaElement(self, manifest, elemendipealkiri):
        "Lisab manifesti elemendi"
        element=self.dom.createElement("item")        
        manifest.getElementsByTagName("organizations")[0].\
          getElementsByTagName("organization")[0].appendChild(element)
        pealkiri=self.dom.createElement("title")
        element.appendChild(pealkiri)
        pealkiri.appendChild(self.dom.createTextNode(elemendipealkiri))
        return element
        
        
    def lisaRessurss(self, manifest):
        "Lisab manifesti ressursi"
        ressurss=self.dom.createElement("resource")
        manifest.getElementsByTagName("resources")[0].appendChild(ressurss)
        return ressurss
        
#    def kirjutaOsad(self):
#       "kirjutab organisatsioonid vastavate alamprogrammide abil - nii manifesti kui kirje organisatsiooni juurde"
#       self.kirjutaRaamaturiiul()
       
       
#    def kirjutaOsa(self, nimetus):
#       "Kirjutab he organisatsiooni ja vljastab selle id"
#       nr=self.loendur.get_next_counter()
#       tekst="COURSE_"+str(nr)
#       itm=self.dom.createElement("item")
#       itm.setAttribute("identifier", tekst)
#       pealkiri=self.dom.createElement("title")
#       pealkiri.appendChild(self.dom.createTextNode(nimetus))
#       itm.appendChild(pealkiri)
#       self.orgn.appendChild(itm)
#       return tekst
       
    def kirjutaRaamatustrukt(self, vanem):
	"kirjutab raamaturiiuli struktuuri"
	riiul=self.dom.createElement("item")
	riiul.setAttribute('identifier','riiul'+self.kursusenr)
	riiul.setAttribute('structure','hierarchical')
	riiul.setAttribute('identifierref','riiul'+self.kursusenr)
	riiul.setAttribute('isvisible','true')
	ex=Exporter(self.iva)
	ex.binarydata=self.binarydata
	ex.exportWebtopFolderStructure(self.kursus, riiul)
	vanem.appendChild(riiul)
	return riiul 
       
    def kirjutaRaamaturiiul(self):
        "Lisab vljundpuusse kursuse raamaturiiuli sisu"
        #rm=self.kirjutaManifest(self.juur, "raamaturiiul")
        rm=self.dom.createElement("raamaturiiul")
	rm.setAttribute("identifier","ivariiul")
        #self.lisaElement(rm, "riiulisisu")
        #r=self.lisaRessurss(rm)
        f=self.dom.createElement("file")
        rm.appendChild(f)
        f.setAttribute("href", "ivariiul.xml")
        self.kirjutaRaamaturiiuliSisu()
        
    def kirjutaRaamaturiiuliSisu(self):
        "Kirjutab raamaturiiuli sisu omaette faili"
        self.riiulidokument=Document()
        riiul=self.riiulidokument.createElement("raamaturiiul")
        self.riiulidokument.appendChild(riiul)
        ex=Exporter(self.iva)
        ex.binarydata=self.binarydata 
          #et lheks samasse hoidlasse
        ex.exportWebtopFolderContents(self.kursus.gf, riiul)
        #d=Dump()
        #alus.writexml(d)
        
    
        
    def kirjutaTestid(self):
        "Lisab vljundpuusse kursusel olevate testide lesanded"


    def pakiTulemusFaili(self, failinimi="ivaarhiiv.zip"):
        "Olemasolevate tkkide phjal luuakse zip-fail"        
        zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        dump = Dump()
        self.dom.writexml(dump)
        zip.writestr(zipfile.ZipInfo("ivamanifest.xml"),dump.getdata())
        #dump = Dump()
        #self.riiulidokument.writexml(dump)
        #zip.writestr(zipfile.ZipInfo("riiul"+self.kursusenr+"/imsmanifest.xml"),dump.getdata())
        for name in self.binarydata.getNames():
            zip.writestr(
                zipfile.ZipInfo(name),
                str(self.binarydata.getData(name)))
        zip.close()
