import zipfile
import xml.dom.minidom
from xml.dom.minidom import Document
from ImportExport import Counter, DataTable, to_utf8, Exporter, Dump

class Kirjutus:
    def __init__(self, ivajuur, kursusenr):
        """Uue eksportkirjutaja loomine. Parameetrina eksporditava iva juurobjekt"""
        # Paisktabel failandmete hoidmiseks
        self.binarydata = DataTable()
        self.idmap = {}
        self.dom=Document()
        self.loendur=Counter()
        self.juur=self.kirjutaManifest(self.dom, "Kursus")
#        self.juur=self.dom.createElement("manifest")
#        self.dom.appendChild(self.juur)
#        self.juur.appendChild(self.dom.createElement("metadata"))
#        self.orgd=self.dom.createElement("organizations")
#        self.juur.appendChild(self.orgd)
#        self.orgn=self.dom.createElement("organization")
#        self.orgd.appendChild(self.orgn)
        self.iva=ivajuur
        self.kursusenr=kursusenr
#        print "nr "+str(kursusenr)
        self.kursus=getattr(ivajuur.courses, str(kursusenr))
        self.kirjutaOsad()
        
    def kirjutaManifest(self, alus, pealkiri=""):
        "Manifesti ploki loomine"
        m=self.dom.createElement("manifest")
        md=self.dom.createElement("metadata")
        m.appendChild(md)
        lom=self.dom.createElement("lom")
        md.appendChild(lom)
        t=self.dom.createElement("title")
        lom.appendChild(t)
        t.appendChild(self.dom.createTextNode(pealkiri))
        o=self.dom.createElement("organizations")
        m.appendChild(o)
        orgn=self.dom.createElement("organization")
        o.appendChild(orgn)
        m.appendChild(self.dom.createElement("resources"))
        alus.appendChild(m)
        return m
        
    def lisaElement(self, manifest, elemendipealkiri):
        "Lisab manifesti elemendi"
        element=self.dom.createElement("item")        
        manifest.getElementsByTagName("organizations")[0].\
          getElementsByTagName("organization")[0].appendChild(element)
        pealkiri=self.dom.createElement("title")
        element.appendChild(pealkiri)
        pealkiri.appendChild(self.dom.createTextNode(elemendipealkiri))
        return element
        
        
    def lisaRessurss(self, manifest):
        "Lisab manifesti ressursi"
        ressurss=self.dom.createElement("resource")
        manifest.getElementsByTagName("resources")[0].appendChild(ressurss)
        return ressurss
        
    def kirjutaOsad(self):
       "kirjutab organisatsioonid vastavate alamprogrammide abil - nii manifesti kui kirje organisatsiooni juurde"
       self.kirjutaRaamaturiiul()
       
       
#    def kirjutaOsa(self, nimetus):
#       "Kirjutab he organisatsiooni ja vljastab selle id"
#       nr=self.loendur.get_next_counter()
#       tekst="COURSE_"+str(nr)
#       itm=self.dom.createElement("item")
#       itm.setAttribute("identifier", tekst)
#       pealkiri=self.dom.createElement("title")
#       pealkiri.appendChild(self.dom.createTextNode(nimetus))
#       itm.appendChild(pealkiri)
#       self.orgn.appendChild(itm)
#       return tekst
       
       
    def kirjutaRaamaturiiul(self):
        "Lisab vljundpuusse kursuse raamaturiiuli sisu"
        self.lisaElement(self.juur, "raamaturiiul")
        rm=self.kirjutaManifest(self.juur, "raamaturiiul")
        self.lisaElement(rm, "riiulisisu")
        r=self.lisaRessurss(rm)
        f=self.dom.createElement("file")
        r.appendChild(f)
        f.setAttribute("href", "ivariiul.xml")
        self.kirjutaRaamaturiiuliSisu()
        
    def kirjutaRaamaturiiuliSisu(self):
        "Kirjutab raamaturiiuli sisu omaette faili"
        self.riiulidokument=Document()
        riiul=self.riiulidokument.createElement("raamaturiiul")
        self.riiulidokument.appendChild(riiul)
        ex=Exporter(self.iva)
        ex.binarydata=self.binarydata 
          #et lheks samasse hoidlasse
        ex.exportWebtopFolderContents(self.kursus.gf, riiul)
        #d=Dump()
        #alus.writexml(d)
        
    
        
    def kirjutaTestid(self):
        "Lisab vljundpuusse kursusel olevate testide lesanded"


    def pakiTulemusFaili(self, failinimi="ivaarhiiv.zip"):
        "Olemasolevate tkkide phjal luuakse zip-fail"        
        zip = zipfile.ZipFile(failinimi,"w",zipfile.ZIP_DEFLATED)
        dump = Dump()
        self.dom.writexml(dump)
        zip.writestr(zipfile.ZipInfo("ivadom.xml"),dump.getdata())
        dump = Dump()
        self.riiulidokument.writexml(dump)
        zip.writestr(zipfile.ZipInfo("ivariiul.xml"),dump.getdata())
        print "Riiul failis"
        for name in self.binarydata.getNames():
            zip.writestr(
                zipfile.ZipInfo(name),
                str(self.binarydata.getData(name)))
        zip.close()
