# IVA vocabulary file, generated by NoteTab
# $Id: vocabulary_de.py,v 1.7 2003/08/18 07:44:24 berlingo Exp $
#
# Copyright 2003 by IVA Team and contributors
#
# This file is part of IVA.
#
# IVA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# IVA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with IVA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

"""Contains the english translations for all IVA printable strings."""

# How to do a new translation:
#
# 1. Copy this file into a new file, appending the language code after it, so
# you get something like "vocabulary_es.py" for Spanish and so on.
#
# 2. Edit the new file, translating the second portion of each line. The
# first portion is the keyword, which you shouldn't touch. The second is the
# translation that should be translated to the target language. The third
# is the supplementary instruction, that should help you do the translations.
#
# 3. Please note that the file is in Python code and needs to follow certain
# syntax rules:
#  - Strings can either be quoted by singles quotes (') or double quotes (").
#    If you need to use either of these quotation marks in your translation,
#    make sure that you use the other quotation mark to surround the string.
#    If you need to use both quotation marks in the same translation string,
#    you can surround the string with triple quotes (''' or """), which
#    allows you to use either of the quotation marks inside the string.
#  - Line breaks are not allowed inside strings, so make sure you don't
#    use an editor that wraps lines. You can have line breaks between
#    strings, though.
#
# 4. If you need to use special characters (outside of the 127 character
# ASCII range), you have several choices:
#
# A. Write in your native encoding (whatever suits you best). This requires
#    that you change the "charset_encoding" keyword in the "common" module to
#    the encoding type you will use. This document is written in iso8859-1,
#    although as english does not contain special characters, it could be
#    in utf-8 as well without any differences.
#    Most European languages are easiest to write in iso8859-1.
#
# B. Write in utf-8 encoded unicode. If your editor can save files in utf-8,
#    use that feature. If not, you can add the special characters manually
#    with the \x escape sequences. Make sure you remove the keyword
#    "charset_encoding" from the "common" module, or change its value to
#    "utf-8" so that the strings are interpreted correctly.
#    'key': ('\xe3\x82\xaa','This is the katakana letter O,encoded in utf-8.'),
#
# C. Write in unicode. Each unicode string starts with u followed by the
#    quotes. Each unicode character starts with \u followed by the code in
#    hexadecimal notation. The value of the "charset_encoding" keyword
#    is irrelevant if you use unicode all the way.
#    'key': (u'\u30aa','This is the katakana letter O, encoded in unicode.'),
#
# 5. Check your translation. If you have Python installed and you've
#    downloaded IVA sources, you can execute "python TranslationLint.py"
#    which will check through all the translation files and will produce
#    an error if there is a syntax error.
#    If you have installed IVA, you can test the translation yourself
#    by going to Zope Management and selecting the Tools tab in your IVA
#    instance, and clicking on "reload_translations". After this you
#    should be able to select your translation from user preferences
#    and see the translated strings.
#
"""Contains the German translations for all IVA printable strings."""

common = {'language_name':
 ('Deutsch', 'Name of this language'),
 'charset_encoding':
 ('ISO-8859-1', 'Encoding used in this translation (if missing, utf-8 is assumed'),
 'WebTop':
 ('WebTop', 'Main tab for webtop'),
 'Knowledge_Building':
 ('Wissen aufbauen', 'Main tab for knowledge building'),
 'Course_Management':
 ('Kursverwaltung', 'Main tab for course management'),
 'User_Management':
 ('Benutzerverwaltung', 'Main tab for user management'),
 'Jamming':
 ('Jamming', 'Main tab for jamming'),
 'Type_Management':
 ('Wissenstypenverwaltung', 'Heading'),
 'cancel':
 ('Abbrechen', 'Button label'),
 'submit':
 ('Abspeichern', 'Button label'),
 'remove':
 ('Entfernen', 'Button label'),
 'next':
 ('Weiter ->', 'Label for button'),
 'previous':
 ('<- Zurck', 'Label for button'),
 'quick_submit':
 ('Schnelleingabe', ''),
 'ok':
 ('Ok', 'Button label'),
 'webtop':
 ('WepTop', ''),
 'description':
 ('Beschreibung', 'Label'),
 'short_date_format_display':
 ('JJJJ-MM-DD', 'String displayed as clue when entering a date'),
 'short_date_format':
 ('%Y-%m-%d', 'Format string for short dates'),
 'timestamp_format':
 ('%H:%M %Y-%m-%d', 'Format string for long timestamps'),
 'invite':
 ('Einladen', ''),
 'add':
 ('Hinzufgen', ''),
 'today':
 ('Heute', ''),
 'yesterday':
 ('Gestern', ''),
 'groupfolder':
 ('Gruppenverzeichnis', 'Heading'),
 'dtml_reloaded':
 ('DTML neu geladen', 'Title for message dialog'),
 'dtml_files_reloaded':
 ('DTML Dateien fr dieses Objekt neu geladen', 'Message dialog text'),
 'dtmls_reloaded':
 ('DTMLs neu geladen', 'Title for message dialog'),
 'dtmls_files_reloaded':
 ('Alle DTML Dateien neu geladen', 'Message dialog text'),
 'css_reloaded':
 ('Style-Sheets neu geladen', 'Title for message dialog'),
 'css_files_reloaded':
 ('Style-Sheet fr dieses Objekt neu geladen', 'Message text'),
 'error':
 ('Fehler', ''),
 'warning':
 ('Warnung', ''),
 'invalid_url':
 ('Ungltige URL', 'Message title'),
 'give_valid_url':
 ('Bitte eine gltige URL eingeben', 'Message text'),
 'invalid_name':
 ('Ungltiger Name', 'Message title'),
 'give_valid_name':
 ('Bitte einen gltigen Namen eingeben', 'Message text'),
 'name_taken':
 ('Ein anderer Eintrag hat bereits den Namen "%s". Bitte tragen Sie einen anderen Namen ein.',
  'Message text, name inserted inside'),
 'edit':
 ('Editieren', 'Button label'),
 'you_are_in':
 ('Sie befinden sich in:',
  'Heading, without trailing colon - keep in translation if needed'),
 'required_field_missing':
 ('Sie haben nicht alle notwendigen Felder ausgefllt.',
  'Erro message text'),
 'confirmation':
 ('Besttigung', 'Title for confirmation dialogs'),
 'invalid_input':
 ('Ungltige Eingabe', 'Message title'),
 'invalid_fields':
 ('Das folgende Feld enthlt eine ungltige Eingabe',
  'Message text followed by a list of field names'),
 'select_item_first_common':
 ('Whlen Sie zuerst einige Eintrge', 'Message text'),
 'link_to_webtop':
 ('Verknpfung auf dem WebTop erstellen', 'Link'),
 'proxy_to_webtop':
 ('Kursordner in WebTop erzeugen', 'Link'),
 'export':
 ('Exportieren', 'Button label'),
 'import':
 ('Importieren', 'Button label'),
 'importing':
 ('Importieren', 'Heading start'),
 'megabyte':
 ('MB', 'Abbreviation for megabyte'),
 'kilobyte':
 ('KB', 'Abbreviation for kilobyte'),
 'logout':
 ('Abmelden', 'Link for logging out'),
 'logout_pre':
 ("Um Abmelden, schlie&szlig;en Sie entweder Ihr Browserfenster oder drcken Sie auf 'Abmelden' unten. Drcken Sie auf 'Abbrechen' wenn Sie nach Ihren Benutzerinformationen gefragt werden. Dadurch werden Ihre vom Browser zwischengespeicherten Benutzerinformationen gelscht.",
  'Instructions on logging out'),
 'logout_post':
 ('Sie wurden ausgeloggt.', 'Logout notification'),
 'login':
 ('Einloggen', 'Link to log in')}

kb = {'course_info':
 ('Kursinformationen', 'Label for link to course details'),
 'create_context':
 ('Neuen Kurskontext anlegen', 'Link to create new course context'),
 'hide_context':
 ('Kontext verbergen', 'Link to hide a context from view'),
 'show_context':
 ('Kontext zeigen', 'Link to show a hidden context'),
 'new_notes':
 ('Neue Eintrge',
  'Label for showing the number of new notes, eg. "5 new notes"'),
 'notes_total':
 ('Eintrge', 'Label for showing the number of notes'),
 'full_description':
 ('ganze Beschreibung...', ''),
 'course':
 ('Kurs', "String 'course' in context display"),
 'context':
 ('Kontext', "String 'context' in context display"),
 'thread':
 ('Diskussionsbeitrag', "String 'thread' in s display"),
 'note':
 ('Eintrag', "String 'note' in context display"),
 'start_new_thread':
 ('Neuer Diskussionsbeitrag', 'Link'),
 'short_description':
 ('Kurze Beschreibung', 'Label'),
 'long_description':
 ('Lange Beschreibung', 'Label'),
 'full_description':
 ('Vollstndige Beschreibung', 'Label'),
 'select':
 ('Auswhlen',
  'Start of sentence, followed by a drop-down list of available knowledge types'),
 'knowledge_type':
 ('Wissenstyp', 'Label'),
 'reply':
 ('Antworten', 'Button label'),
 'show_notes':
 ('Beitrge zeigen', 'Heading start'),
 'show_thread':
 ('nach Beitrag', 'heading finish'),
 'show_type':
 ('nach Wissenstyp', 'heading finish'),
 'show_author':
 ('nach Person', 'heading finish'),
 'show_date':
 ('nach Datum', 'heading finish'),
 'change_course_to':
 ('Kurs wechseln', 'Label, followed by a drop-down list of available courses'),
 'creating_context':
 ('Neuen Kurskontext anlegen in ', 'Title, followed by the course name'),
 'editing_context':
 ('Kurskontext editieren in ', 'Title, followed by the course name'),
 'title_of_context':
 ('Titel des Kurskontexts', 'Label'),
 'type_set':
 ('Wissenstypenmenge', 'Label'),
 'creating_note_in':
 ('Neuen Eintrag erstellen in', 'Title, followed by course context name'),
 'course_context':
 ('Kurskontext', 'Label for course context'),
 'you_are_replying_to':
 ('Sie antworten auf', 'Label'),
 'title_of_note':
 ('Titel des Beitrags', 'Label'),
 'message_body':
 ('Beitrags-Text', 'Label'),
 'current_image':
 ('Aktuelles Bild', 'Label'),
 'replace_with':
 ('Ersetze durch', 'Label for image replacement in note edit'),
 'add_image':
 ('Bild hinzufgen', 'Label'),
 'title_of_image':
 ('Titel fr das Bild', 'Label'),
 'add_link':
 ('Link (URL) hinzufgen', 'Label'),
 'title_of_link':
 ('Titel des Links', 'Label'),
 'preview':
 ('Vorschau', 'Button label'),
 'previewing_note':
 ('Vorschau des Beitrags in',
  'Title/heading, followed by course context name'),
 'publish':
 ('Publizieren', 'Button label'),
 'you_didnt_select_type':
 ('Sie haben keinen Wissenstyp gewhlt.', 'Title'),
 'go_back':
 ('Zurck', 'Start of message, rendered into a link'),
 'and_select_type':
 ('und whlen Sie den Wissenstyp fr den Beitrag.',
  'Rest of message'),
 'inline_notes':
 ('Alle Beitragstexte zeigen', 'Link'),
 'outline_notes':
 ('Alle Beitragstexte verbergen', 'Link'),
 'view_info':
 ('Info anzeigen', 'Part of location bar'),
 'edit_context':
 ('Kurskontext editieren', 'Link'),
 'to_note':
 ('zu Beitrag', 'Part of a message'),
 'notes_from_day':
 ('Beitrge von', 'Start of heading, followed by a date'),
 'full_thread_no':
 ('Nur oberste Beitrge zeigen', 'Link'),
 'full_thread_yes':
 ('Vollstndigen Beitrag zeigen', 'Link'),
 'censor':
 ('Notiz zensieren', 'Button label for censoring notes'),
 'uncensor':
 ('Zensur aufheben', 'Button label for uncensoring notes'),
 'censored_msg':
 ('Nachricht ist zensiert', 'Message shown when teacher censores a note.'),
 'censor_verify':
 ('Wollen Sie wirklich diese Nachricht zensieren? Ihr Name und das Datum werden gespeichert und zusammen mit der Zensur-Nachricht allen die diese Nachricht anschauen wollen gezeigt.',
  'Verification message shown when censoring is attempted'),
 'censored_subject':
 ('Zensiert', 'Title/subject for censored notes'),
 'censored_body':
 ('Diese Nachricht wurde von %s am %s zensiert.',
  "Body for censored messages. First placeholder is replaced by censorer's name and the second by the date"),
 'previous':
 ('zurck', 'Link label'),
 'next':
 ('weiter', 'Link label'),
 'who_has_read':
 ('Leser dieser Nachricht', 'Link label'),
 'last_read':
 ('Zuletzt gelesen', 'Label'),
 'times_read':
 ('mal gelesen', 'Label'),
 'back':
 ('< zurck', 'Link label'),
 'unread_to_read_msg':
 ('Notizen wurden als gelesen markiert.',
  'title and message in a message dialog'),
 'mark_notes_read':
 ('Alle als gelesen markieren', 'text in a button'),
 'creating_groupfolder':
 ('Erzeuge ein neues Gruppenverzeichnis in', 'Heading start'),
 'title_groupfolder':
 ('Titel des Gruppenverzeichnisses', 'Label'),
 'flea_asks':
 ('IVA fragt',
  'Heading displayed in the scaffolding check list.'),
 'change_type':
 ('Wissenstyp ndern?',
  'Question at the end of the scaffolding check list.'),
 'no_change_possible':
 ('Dieser Typ ist als einziger hier erlaubt.',
  'Text displayed when there is only one possible follow-up type and the type cannot be changed.'),
 'change':
 ('ndern', 'Button label'),
 'down_to_note':
 ('Zur Beitragsnotiz', 'Link label')}

webtop = {'users_courses':
 ('Kurse', "Postfix for user's course list heading"),
 'new_notes':
 ('Neue Beitrge',
  'Label for displaying the number of new notes in a course'),
 'total_notes':
 ('insgesamt', 'Label for displaying the total number of notes in a course'),
 'add_folder':
 ('Neuer Ordner', ''),
 'add_document':
 ('Neues Dok.', ''),
 'add_link':
 ('Neuer Link', ''),
 'create_document':
 ('Neues Memo', ''),
 'sort':
 ('Sortieren ', 'Common heading for sort links by_name and by_date'),
 'by_name':
 ('nach Name', 'Link for sorting by name'),
 'by_date':
 ('nach Datum', 'Link for sorting by date'),
 'by_size':
 ('nach Gr&szlig;e', 'Link for sorting by size'),
 'remove':
 ('Entfernen', 'Button label'),
 'restore':
 ('Wiederherstellen', 'Button label'),
 'rename':
 ('Umbenennen', 'Button label'),
 'copy':
 ('Kopieren', 'Button label'),
 'cut':
 ('Ausschneiden', 'Button label'),
 'paste':
 ('Einfgen', 'Button label'),
 'delete':
 ('Lschen', 'Button label'),
 'trash':
 ('Papierkorb', 'Label for trashcan'),
 'adding_folder':
 ('Ordner hinzufgen', 'Heading'),
 'title_of_folder':
 ('Titel des Ordners', 'Label'),
 'viewing_memo':
 ('Memo lesen', 'Title'),
 'adding_memo':
 ('Memo hinzufgen', 'Title'),
 'editing_memo':
 ('Memo editieren', 'Title'),
 'name_of_memo':
 ('Name des Memos', 'Label'),
 'content':
 ('Inhalt', 'Label'),
 'show_memo_contents':
 ('Nur Memo-Inhalte zeigen', 'Link'),
 'adding_link':
 ('Link hinzufgen', 'Title'),
 'title_of_link':
 ('Titel des Links', 'Label'),
 'url':
 ('URL', ''),
 'document_uploaded':
 ('Dokument gespeichert.', 'Status message'),
 'adding_document':
 ('Dokument hinzufgen', 'Title'),
 'upload_document':
 ('Dokument hochladen', 'Label'),
 'title_of_document':
 ('Titel des Dokuments', 'Label'),
 'webtop_link_added':
 ('Vernpfung zum WebTop hinzugefgt', 'Message title'),
 'added_webtop_link':
 ('Eine Verknpfung %s "%s" wurde auf Ihrem WepTop angelegt. Klicken Sie OK um zur vorhergehenden Seite zurckzukehren.',
  'Message text; "to type" and "name" inserted into placeholders (2)'),
 'proxy_added':
 ('Kursverzeichnis erzeugt', 'Message title'),
 'added_proxy':
 ('Das %s-Kursverzeichnis ist nun in Ihrer WepTop sichtbar. Drcken Sie OK um auf die vorherige Sicht zu gelangen.',
  'Message text, course name inserted into placeholder'),
 'no_item_selected':
 ('Keine Eintrge ausgewhlt!', 'Message dialog title'),
 'select_item_first':
 ('Bitte whlen Sie zumindest einen Eintrag um andere Aktionen au&szlig;er "Einfgen" auszufhren.',
  'Message dialog message'),
 'no_file_supplied':
 ('Keine Datei angeboten.', 'Message text'),
 'renaming':
 ('Umbenennen', 'Title'),
 'invalid_names':
 ('Die folgenden Namen sind ungltig:', 'Message dialog messsage'),
 'same_names':
 ('Sie haben mehreren Objekten den selben Namen gegeben.',
  'Message dialog message'),
 'names_in_use':
 ('Die folgenden Namen sind bereits in Verwendung:', 'Message dialog message'),
 'information':
 ('Information', 'Link'),
 'preferences':
 ('Voreinstellungen', 'Link'),
 'editing_preferences':
 ('Einstellungen editieren', 'Title'),
 'shared':
 ('shared', 'Printed after the name of the group folder'),

 #Sorting the users under user management #06.08 by Mart
  'sort_by': ('Sortieren nach','Text before pull-down menu'),
  'limiters': ('Filtrieren nach','Text before pull-down menu'),
  'modified': ('Erstellungsdatum','menu option'),
  'username': ('Benutzername','menu option'),
  'sort': ('Sortieren','button label'),
  'not_specified': ('Nicht festgelegt','default menu option'),
  'email': ('E-mail Adresse','menu option'),
  'fname': ('Vorname','menu option'),  
  'since': ('ab','default value of textbox'),
  'until': ('bis','default value of textbox'), }

usermgmnt = {'user':
 ('Benutzer', 'part of browser title'),
 'adding_users':
 ('Neuen Benutzer hinzufgen', 'Title'),
 'required_field':
 ('Notwendiges Feld', ''),
 'nickname':
 ('Nickname', ''),
 'user_account':
 ('Benutzerkonto', 'Label'),
 'Confirm':
 ('Besttigen', ''),
 'you_are_removing':
 ('Sie lschen', ''),
 'invite_user':
 ('Benutzer einladen', ''),
 'invite_new_users':
 ('Neuen Benutzer einladen', 'Heading for invitation form'),
 'email_addresses':
 ('E-mail Adresse', ''),
 'separate_with_comma':
 ('( getrennt durch: , )', ''),
 'Invitation_message':
 ('Einladungs-Message', ''),
 'Invitation_language':
 ('Sprache der Einladung', ''),
 'Courses_to_invite_to':
 ('Kurs zu der eingeladen werden soll', ''),
 'Freeze':
 ('Deaktivieren', ''),
 'Remove':
 ('Entfernen', ''),
 'role':
 ('Rolle', 'label'),
 'role_staff':
 ('Staff', 'Global role stuff'),
 'role_user':
 ('Benutzer', 'Global role user'),
 'role_fleadmin':
 ('IVA Administrator', 'Global role IVAadmin'),
 'invite_again':
 ('Erneut einladen', 'Button label'),
 'warning':
 ('Warnung', 'Heading'),
 'want_remove_users':
 ('Mchten Sie folgenden Benutzer entfernen?', 'Complete question'),
 'invited_user_manage':
 ('Verwaltung der eingeladenen Benutzer', 'Title'),
 'info_user':
 ('Information ber ',
  'Title for user info page, prefix before usre name'),
 'edit_user':
 ('Benutzer editieren', 'Link'),
 'name':
 ('Benutzername', ''),
 'editing':
 ('Editieren:', 'Heading for user edit, inserted before user name'),
 'image_of_user':
 ('Bild des Benutzers', 'Label'),
 'upload_image_of_user':
 ('Bild des Benutzers hochladen', 'Label'),
 'or_link_to_image':
 ('oder Link zu einem Bild des Benutzers',
  'Label, continuing from the upload label'),
 'add_new_user':
 ('Neuen Benutzer hinzufgen', 'Title'),
 'webtop_bg':
 ('WebTop Hintergrund', 'Label'),
 'upload_webtop_bg':
 ('oder eigenen Hintergrund hochladen',
  'Label, continuing from the webtop_bg'),
 'show_pending_users':
 ('Nicht registrierte zeigen', ''),
 'add_user':
 ('Benutzer hinzufgen', ''),
 'Unfreeze':
 ('Reaktivieren', ''),
 'Users':
 ('Benutzer', ''),
 'gsm':
 ('Mobile', ''),
 'last_name':
 ('Nachnname', ''),
 'first_name':
 ('Vorname', ''),
 'city':
 ('Stadt', ''),
 'organization':
 ('Organisation', ''),
 'professional_interests':
 ('Berufliche Interessen', ''),
 'email':
 ('Email', ''),
 'phone':
 ('Telefon', ''),
 'language':
 ('Sprache', ''),
 'url_to_photo':
 ('URL zum Bild', ''),
 'country_menu_default':
 ('Land auswhlen', ''),
 'group_menu_default':
 ('Gruppe auswhlen', 'Default value for drop-down menu'),
 'address':
 ('Adresse', ''),
 'address1':
 ('Adresszeile 1', ''),
 'address2':
 ('Adresszeile 2', ''),
 'personal_interests':
 ('Persnliche Interessen', ''),
 'quote':
 ('Zitat', ''),
 'homepage':
 ('Homepage', ''),
 'upload':
 ('Hochladen', ''),
 'group':
 ('Gruppe', ''),
 'password':
 ('Passwort', ''),
 'background':
 ('Hintergrund', ''),
 'country':
 ('Land', ''),
 'reserved_nickname':
 ('Sorry. Dieser Nickname ist bereits vergeben.', 'Message'),
 'password_mismatch':
 ('Eingegebenen Password stimmt nicht.', 'Message'),
 'could_not_send_invitation':
 ('Einladung konnte nicht verschickt werden. Bitte kontrollieren Sie Einstellungen des MailHost-Objekts.',
  'Error message'),
 'invitations_sent':
 ('Einladung verschickt', 'Message title'),
 'invitations_sent_to':
 ('Einladung verschickt an %s. ',
  'Message, email list is inserted into the placeholder.'),
 'users_removed':
 ('Benutzer entfernt', 'Message title'),
 'removed_users':
 ('Benutzer entfernt: %s', 'Message, list inserted inside'),
 'not_removed_users':
 ('Entfernen folgender Benutzer nicht mglich: %s',
  'Message, list inserted inside'),
 're_invitations_sent':
 ('Erneute Einladung veschickt', 'Message title'),
 're_invitations_sent_to':
 ('Erneute Einladung verschickt an %s user. ',
  'Message, email count is inserted into the placeholder.'),
 'pending_users_removed':
 ('Zurckgestellter Benutzer entfernt', 'Message title'),
 'pending_removed_users':
 ('Zurckgestellter Benutzer entfernt: %s',
  'Message, list inserted inside'),
 'pending_not_removed_users':
 ('Enfernen folgender zurckgestellter Benutzer nicht mglich: %s',
  'Message, list inserted inside'),
 'invitation_subject':
 ('Einladung in IVA', 'Subject for invitation messages'),
 'invitation_header':
 ('Einladung', 'Header for invitation messages'),
 'invitation_footer':
 ('Bitte besuchen Sie: ',
  'Footer for invitation messages; followed by the URL'),
 'welcome_message':
 ('Willkommen bei IVA. Bitte tragen Sie unten Ihre Benutzerdaten ein.',
  'Welcome message used in invitation registration form'),
 'uname':
 ('Benutzername', 'Label used in invitation registration form'),
 'registration_failed':
 ('Registrierung fehlgeschlagen',
  "Title used when invited user can't register."),
 'invitation_key_used':
 ('Dieser Einladungs-URL wurde schon verwendet oder ist nicht mehr gltig. Wenn Sie sich nicht anmelden konnten, kontaktieren Sie bitte Ihren Lehrenden um eine neue Einladung zu erhalten.',
  'Message telling that the registration url has been used.'),
 'authorization_failed':
 ('Authentisierungs-Schlssel sind ungltig',
  "Message telling that the authentication key isn't valid."),
 'after_submit_give_name_and_passwd':
 ('Nach einem Klick auf "Eingabe" geben Sie bitte Benutzername und Password ein.',
  'Message'),
 'frozen':
 ('Deaktiviert', 'User status code'),
 'no_email':
 ('Keine Email-Adresse', 'Message title'),
 'no_email_explanation':
 ('Sie knnen keine mails verschicken, weil Sie Ihre Email-Adresse nicht eingegeben haben.',
  'Message text'),
 'passwd_changed':
 ('Passwort wurde gendert', 'Message title'),
 'passwd_changed_explanation':
 ('Sie haben Ihr Passwort gendert: Ihr Browser wird Sie nach Ihren Zugangsinformationen fragen.',
  'Message text')}

coursemgmnt = {'course':
 ('Kurs', 'part of browser title'),
 'courses':
 ('Kurse', 'Title'),
 'add_course':
 ('Neuer Kurs', 'Link'),
 'edit_course':
 ('Kurs editieren', 'Button label'),
 'edit_participants':
 ('Teilnehmer editieren', 'Button label'),
 'creating_course':
 ('Neuen Kurs anlegen', 'Title'),
 'editing_course':
 ('Kurs editieren', 'Title'),
 'course_name':
 ('Kurs Name', 'Label'),
 'organization':
 ('Organisation', 'Label'),
 'methods':
 ('Methoden', 'Label'),
 'starting_date':
 ('Startdatum', 'Label'),
 'ending_date':
 ('Enddatum', 'Label'),
 'create_groupfolder':
 ('Erzeugen neues Gruppenverzeichnis', 'Link'),
 'adding_users_to_course':
 ('Neue Kursteilnehmer hinzufgen',
  'Title, name of course is displayed after this'),
 'if_participants_not_users':
 ('Falls die neuen Kursteilnehmer noch keine IVA-Benutzer sind', 'Message'),
 'new_participants_to_system':
 ('eines neuen Benutzers ', 'Part of a phrase'),
 'by_email':
 ('ber Email', 'Part of a phrase'),
 'manually':
 ('per Hand', 'Part of a phrase'),
 'fle_users':
 ('IVA-Benutzer', 'Heading'),
 'down':
 ('nach unten', 'Button label'),
 'up':
 ('nach oben', 'Button label'),
 'teachers':
 ('Lehrende', 'Heading'),
 'tutors':
 ('Tutoren', 'Heading'),
 'students':
 ('Studenten', 'Heading'),
 'add_button':
 ('Hinzufgen ->', 'Button label'),
 'remove_button':
 ('<- Entfernen', 'Button label'),
 'no_course_selected':
 ('Kein Kurs ausgewhlt!', 'Message dialog title'),
 'select_course_first':
 ('Bitte whlen Sie einen Kurs aus der Liste.', 'Message dialog message'),
 'set_published':
 ('Wissenstypen-Liste publiziert', 'Message dialog title/text'),
 'users_updated':
 ('Benutzer aktualisiert', 'Message dialog title/message'),
 'select_some_users':
 ('Bitte whlen Sie einige Benutzer aus', 'Message dialog title/message'),
 'edit_course_info':
 ('Kursinformation editieren', 'Link'),
 'edit_course_participants':
 ('Kursteilnehmer editieren', 'Link'),
 'date':
 ('Datum', 'Label, followed by the starting and ending date of the course.'),
 'course_participants':
 ('Kursteilnehmer', 'Label'),
 'type_sets':
 ('Wissenstypenmengen', 'Label, plural'),
 'delete':
 ('Lschen', 'Button label'),
 'new_typeset':
 ('Wissenstypenmenge', 'Link'),
 'tt_yellow':
 ('Gelb', 'Knowledge type colour name'),
 'tt_yellowlt':
 ('Hellgelb', 'Knowledge type colour name'),
 'tt_orange':
 ('Orange', 'Knowledge type colour name'),
 'tt_orangelt':
 ('Hellorange', 'Knowledge type colour name'),
 'tt_red':
 ('Rot', 'Knowledge type colour name'),
 'tt_pink':
 ('Pink', 'Knowledge type colour name'),
 'tt_purple':
 ('Purpur', 'Knowledge type colour name'),
 'tt_blue':
 ('Blau', 'Knowledge type colour name'),
 'tt_bluelt':
 ('Hellblau', 'Knowledge type colour name'),
 'tt_aqua':
 ('Aqua', 'Knowledge type colour name'),
 'tt_green':
 ('Grn', 'Knowledge type colour name'),
 'tt_greenlt':
 ('Hellgrn', 'Knowledge type colour name'),
 'tt_gray':
 ('Grau', 'Knowledge type colour name'),
 'tt_white':
 ('Wei&szlig;', 'Knowledge type colour name'),
 'edit_typeset':
 ('Wissenstypen-Liste editieren', 'Heading'),
 'create_typeset':
 ('Neue Wissenstypenmenge erstellen', 'Heading'),
 'form':
 ('Formular', 'Start of heading'),
 'name':
 ('Titel', 'Start of label'),
 'of_typeset':
 ('fr die Wissenstypenmenge', 'Ending of label'),
 'abbreviations_and_icons':
 ('Abkrzungen und Icons', 'Ending for heading'),
 'type':
 ('Wissenstyp', 'Label'),
 'types':
 ('Wissenstypen', 'Title'),
 'abbreviation':
 ('Abkrzung', 'Label'),
 'color':
 ('Farbe', 'Label'),
 'icon':
 ('Icon', 'Label'),
 'starting_phrase':
 ('Einleitungs-Phrase', 'Label'),
 'checklist':
 ('Liste berprfen', 'Label'),
 'no_types_entered':
 ('Sie haben einen Wissenstyp angegeben. Eine Menge besteht aus mindestens einem Typen.',
  'Error message for when a new set is created with no types'),
 'restrictions_of_use':
 ('Verwendungseinschrnkung', 'Heading sentence.'),
 'that_can_start_thread':
 ('das kann einen neuen Diskussionsbeitrag erffnen', 'End of label'),
 'viewing_type':
 ('unter', 'Part of location bar'),
 'new_typeset_from':
 ('Duplizieren und Editieren des Wissenstyps ',
  'Link, followed by knowledge type set name'),
 'unfinished':
 ('unvollstndig', 'Label'),
 'manage_types':
 ('Wissenstypen verwalten', 'Link'),
 'finalize_typeset':
 ('Status auf "fertig" setzen', 'Button label'),
 'are_you_sure':
 ('Sind Sie sicher, dass Sie die folgenden Kurse lschen wollen:',
  'Message dialog message'),
 'are_you_sure_ctx':
 ('Sind Sie sicher, dass Sie diesen Kurskontext lschen wollen:',
  'Message dialog message'),
 'are_you_sure_tts':
 ('Sind Sie sicher, dass Sie diese Wissenstypen lschen wollen:',
  'Message dialog message'),
 'typeset_importing':
 ('Bitte zum Import die Zip-Datei mit der Wissenstypmenge auswhlen.',
  'Instructions for typeset importing'),
 'typesets_imported':
 ('Neue Wissenstypmenge wurde importiert.', 'Message'),
 'import_typeset':
 ('Wissenstypmenge importieren', 'link'),
 'course_importing':
 ('Bitte zum Import die Zip-Datei mit den Kursen auswhlen.',
  'Instructions for course importing'),
 'courses_imported':
 ('Neue Kurse wurden importiert.', 'Message'),
 'import_course':
 ('Kurse importieren', 'link')}

jam = {'add_new_jam_session':
 ('Neue Session hinzufgen', 'link'),
 'jam_sessions':
 ('Jam-Sessions:', 'a list of jam session will listed after/under this label'),
 'jam_session':
 ('Jam-Session', ''),
 'annotations':
 ('Anmerkungen', ''),
 'continue_with_version':
 ('Mit Ihrer Fassung weiterarbeiten', 'button label'),
 'artefact':
 ('Artefakt', ''),
 'viewing_annotations':
 ('Anmerkungen anschauen', ''),
 'Annotations':
 ('Anmerkungen:', 'Label, followed by a list of annotations under it'),
 'add_annotation':
 ('Anmerkung hinzufgen', 'link'),
 'adding_new_jam_session':
 ('Neue Session erzeugen', ''),
 'title_of_jam_session':
 ('Titel', 'label'),
 'type_of_jam_session':
 ('Typ der Jam-Session', 'label'),
 'mutate_on_previous':
 ('Vorgnger anpassen', 'type of jam session'),
 'explore_possibilities':
 ('letzte Version als Vorlage', 'type of jam session'),
 'diverge_and_converge':
 ('Entflechten&Zusammenfhren', 'type of jam session'),
 'description_of_jam_session':
 ('Beschreibung der Session', 'label'),
 'upload_the_starting_artefact':
 ('Das Anfangsartefakt hochladen', 'label'),
 'name_of_the_starting_artefact':
 ('Names des Anfangsartefakts', 'label'),
 'annotation_of_the_starting_artefact':
 ('Anmerkung zum ersten Artefakt', 'label'),
 'adding_new_artefact':
 ('Neues Artefakt hinzufgen', ''),
 'name_of_the_artefact':
 ('Artefaktname', 'label'),
 'upload_file':
 ('Datei laden', 'label'),
 'you_adding_annotation':
 ('Sie fgen eine Anmerkung an das Artefakt hinzu',
  'message in adding annotations form'),
 'adding_annotation':
 ('Anmerkung hinzufgen an', ''),
 'to_jam_session':
 ('zu einer Session', 'Part of a message'),
 'to_jam_artefact':
 ('zu einem Session-Artefakt', 'Part of a message'),
 'unread_artefacts':
 ('Neue Artefakte', 'There is a number before this message'),
 'total_artefacts':
 ('Anzahl der Artefakte', 'There is a number before this message'),
 'are_you_sure_jam_sessions':
 ('Wollen Sie wirklich die folgenden Sessions lschen:',
  'Message dialog message'),
 'censor_artefact':
 ('Zensiertes Artefakt', 'Button label for censoring jam artefact'),
 'uncensor_artefact':
 ('Unzensiertes Artefakt', 'Button label for uncensoring jam artefact'),
 'censor_annotation':
 ('Ausgewhlte Anmerkungen zensieren',
  'Button label for censoring jam annotations'),
 'uncensor_annotation':
 ('Zensur fr ausgewhlte Anmerkung aufheben',
  'Button label for uncensoring jam annotations'),
 'censored_name':
 ('Zensiert', 'Title/name for censored jam artefact'),
 'censored_message':
 ('Dieses Artefakt wurde von %s am %s zensiert.',
  "First placeholder is replaced by censorer's name and the second by the date"),
 'censored_msg':
 ('Artefakt ist zensiert', 'Message shown when teacher censores an artefact.'),
 'censored_annotation_msg':
 ('Anmerkung ist zensiert',
  'Message shown when teacher censores an annotation.'),
 'censor_verify':
 ('Wollen Sie wirklich dieses Artefakt zensieren? Ihr Name und das Datum werden gespeichert und zusammen mit der Zensur-Nachricht allen die dieses Artefakt anschauen wollen gezeigt.',
  'Verification message shown when censoring is attempted'),
 'censor_annotations_verify':
 ('Wollen Sie wirklich diese Anmerkung zensieren? Ihr Name und das Datum werden gespeichert und zusammen mit der Zensur-Nachricht allen die diese Anmerkung anschauen wollen gezeigt.',
  'Verification message shown when censoring is attempted'),
 'censored_annotation_body':
 ('Diese Anmerkung wurde von %s am %s zensiert.',
  "Body for censored annotation. First placeholder is replaced by censorer's name and the second by the date")}


    
ivacommon = {
  #editform.dtml - ZWiki 
  'ic_zwiki_change':('Verndern','Button - Change WikiPage contents'),
  #jooksva_kursuse_nimi.dtml
  'ic_no_course_selected':('Kein Kurs ausgewhlt','Message - Course not selected'),
  #kasutajakursused_valik.dtml
  'ic_select_course':('Whlen Sie den Kurs aus','Default menu option - Select course'),
  'ic_change_course':('Wechseln','Button - Change course'),
  'ic_not_added_to_courses':('Sie sind zu keinem Kurs angemeldet','Message - Not registered to any course'),


  'ic_zwiki_modifiers':('verndert von','breadcrumbs'), #05.08
  'ic_zwiki_who_modified':('Wer hat das verndert?','Heading'), #05.08
  'ic_zwiki_nobody_modified':('Das hat noch keiner verndert','Message'), #05.08

  #Webtop/index_html.dtml #16.02 - by Mart
  'ic_make_public':('Publizieren','Button label - Publish object from Drawer to Portfolio'),

  #kaustadkursusel.dtml #16.02 - by Mart
  'ic_no_folders':('Kein Ordner fr den Kurs angelegt','Message - No folders in this course'),
  'ic_course_info':('Kursinformationen','Left menu item - Course info'),
  
  #tootoad_kursusel.dtml #16.02
  'ic_knowledge_building_link':('Wissen aufbauen','Left menu item - Knowledge Building'),
  'ic_jamming_link':('Jamming','Left menu item - Jamming'),
  'ic_wiki_link':('Wiki','Left menu item - Wiki'),
  'ic_no_course_selected':('Kein Kurs ausgewhlt','Message - Course not selected'),

  #tootubade_leht.dtml #16.02 - 14
  'ic_workshops_1':('Werkstuben','Breadcrumb - Workshops'),

  #test_opilane.dtml #16.02
  'ic_test_list':('Tests', 'Menu header - list of quizzes'),

  #halduseleht.dtml #16.02
  'ic_management_page':('Verwaltung','Breadcrumbs'),
    

  #opetaja_menyy.dtml
  'ic_user_management':('Benutzerverwaltung','Left menu item - User management'),
  'ic_inner_group_management':('Teilgruppenverwaltung','Left menu item - Subgroup management'),
  'ic_test_management':('Verwaltung von Tests','Left menu item - Quiz management'),
  'ic_course_management':('Kursverwaltung','Left menu item - Course management'),
  #sisegrupi_lisamise_leht.dtml
  'ic_problem_in_adding_inner_group':('Fehler. Eine Gruppe mit dem gleichen Name ist schon vorhanden.','Error message'),

  #sisegrupiloetelu.dtml #16.02
  'ic_inner_groups_list':('Teilgruppen','Left menu item - Subgroups'),
  
  #sisegrupi_lisamise_vorm.dtml  #16.02
  'ic_name_of_new_group':('Name fr die neue Teilgruppe','Form field - Name of new subgroup'),
  'ic_create_new_group':('erstellen','Button label - Create subgroup'),
  'ic_inner_group_management_3':('Teilgruppenverwaltung','Breadcrumbs - Subgroup management'),
  'ic_adding_inner_group_2':('erstellen','Breadcrumbs - Creating subgroup'),

  #sisegrupikustutusvorm.dtml #16.02
  'ic_inner_group_management_4':('Teilgruppenverwaltung','Breadcrumbs - Subgroup management'),
  'ic_inner_group_deleting':('lschen','Breadcrumbs - Deleting subgroup'),
  'ic_remove_inner_group':('Teilgruppe entfernen','Button label - Delete subgroup'),

  #sisegrupi_osaliste_vorm #16.02
  'ic_inner_group_management_5':('Teilgruppenverwaltung','Breadcrumbs - subgroup management'),
  'ic_inner_group_participants':('Mitglieder','Breadcrumbs - subgroup participants'),
  'ic_inner_group_other_course_participants':('Kursmitglieder','Table header - course participants'),
  'ic_inner_group_participants_in_group':('Mitglieder der Teilgruppe','Table header - list of subgroup participants'),
  'ic_inner_group_change_participants':('ndern','Button label - Change subgroup member list'),

 
  #sisegrupihaldus.dtml
  'ic_inner_group_management_2':('Teilgruppenverwaltung','Breadcrumbs - subgroup management'), #16.02
  'ic_adding_inner_group':('Teilgruppe hinzufgen','Link label - Subgroup'),
  'ic_deleting_inner_group':('Teilgruppe lschen','Link label - Delete subgroup'),
  'ic_managing_inner_group_users':('Mitglieder der Teilgruppe','Table header - Subgroup members'),
     
  
  #veebilauaviited.dtml
  'ic_portfolio':('Portfolio','Left menu item - Portfolio'),
  'ic_drawer':('Schublade','Left menu item - Drawer'),
  'ic_wiki':('Wiki','Menu item - Wiki'),

  #FLE.py
  'ic_help':('Help','Button - Help on Main screen'), #16.02
  #hdr.dtml
  'ic_hdr_drawer':('Schublade','Breadcrumbs - Drawer'),  #16.02 see ja jrgmised 4
  'ic_hdr_portfolio':('Portfolio','Breadcrumbs - Portfolio'),
  'ic_hdr_context':('Bcherregal','Breadcrumbs - Bookshelf'),
  'ic_hdr_workshop':('Werkstuben','Breadcrumbs - Workshops'),
  'ic_hdr_management':('Verwaltung','Breadcrumbs - Management'),
  'ic_hdr_inner_group_name':('Teilgruppe','Breadcrumbs - Subgroup'),

  #kasutajateemataust.dtml #07.04 Jaagup (Alt-text for Upper Menu Images)
  'ic_t_webtop':('Dein persnlicher Desktop im WEB','Picture alt text'),
  'ic_t_context':('Kurskontext vom Lehrer vorbereitet','Picture alt text'),
  'ic_t_workshop':('Werkzeuge fr Zusammenarbeit','Picture alt text'),
  'ic_t_management':('Kursen-, Benutzer-, Teilgruppen- und Testverwaltung','Picture alt text'),
  'ic_t_':('','Picture alt text'),
  'ic_t_':('','Picture alt text'),

  
  #ui/CourseManager/index_html.dtml #05.08
  'ic_add_users':('Benutzer hinzufgen','Link'),

  #ui/Course/index_html.dtml #16.02
  'ic_kb_1':('Wissen aufbauen','Breadcrumbs - Knowledge Building'),

  #ui/Jamming/index_html.dtml #16.02
  'ic_jam_1':('Jamming','Breadcrumbs - Jamming'),

  #standard_wiki_footer.dtml #16.02
  'ic_change_wiki_page':('Seite editieren','Link label - Edit page'),
  'ic_add_wiki_comment':('Kommentar hinzufgen','Button label - Add comment'),
  '':('',''),

  #menu images  #kasutajateemataust.dtml hdr.dtml #16.02
  'ic_picture_webtop_1':('webtop1_de','Upper menu item picture filename'),
  'ic_picture_webtop_2':('webtop2_de','Color bar header picture filename'),
  'ic_picture_bookshelf_1':('bookshelf1_de','Upper menu item picture filename'),
  'ic_picture_bookshelf_2':('bookshelf2_de','Color bar header picture filename'),
  'ic_picture_management_1':('management1_de','Upper menu item picture filename'),
  'ic_picture_management_2':('management2_de','Color bar header picture filename'),
  'ic_picture_workshops_1':('workshops1_de','Upper menu item picture filename'),
  'ic_picture_workshops_2':('workshops2_de','Color bar header picture filename'),

  #Cruft.py
  'ic_user_not_found':('Benutzer nicht gefunden','message'), #29.03
  'ic_no_user_data_in_this_course':('Benutzer hat in diesm Kurs keine Daten','message'),
  'ic_no_events_for_user':('Benutzer hat in diesem Kurs keine Ereignisse','message to the viewer of event'),

  'ic_info_user_name':('Benutzername','Table column heading'), #01.04
  'ic_info_number_open_pages':('Pages geffnet','Table column heading'),
  'ic_info_added_kb_notes':('Gepostet','Table column heading'),
  'ic_info_read_kb_notes':('Gelesen','Table column heading'),
  'ic_info_added_jamming_artefacts':('Mediadateien','Table column heading'),
  'ic_info_test_results':('Tests','Table column heading'),
  'ic_info_last_access':('Letzter Zugriff','Table column heading'),
  'ic_info_total_mark':('Gesamtzensur','Table column heading'),
  'ic_info_comment':('Kommentar','Table column heading'),
  'ic_info_save':('Speichern','Button label'),

  'ic_mail_to_all':('Gruppen-E-Mail senden', 'Link label'), #07.04 Jaagup
  'ic_course_statistics':('Kursstatistik', 'Link label'),
  'ic_user_adding':('Benutzer hinzufgen','Breadcrumbs'), #05.08
  'ic_user_names':('Gewnschte Benutzernamen','Heading'), #05.08
  'ic_user_create':('Ausfhren','Button label'),#05.08
  
  #kylastajateLoetelu (WebtopFolder.py)  #05.04 Mart
  'ic_name':('Name','Table column heading'),
  'ic_date':('Datum','Table column heading'),  
  'ic_nobody_read':('Das hat noch keiner gelesen','Message text'),
  'ic_viewed_by':('Wer hat das gelesen?','Page heading'),
  'ic_viewers':('Besichtiger','Breadcrumbs'),
  '':('',''),
  '':('',''),


}

ivatests = {
  #Prefix it - Iva Test
  #YlTest.py
  'it_save_title':('Testname speichern','Button label - Save the title of quiz'),
  'it_description_of_permissions':('Zugangsrechte','Header - Description of permissions'),
  'it_all_permission':('alle Teilnehmer','Link label - All course participants can solve the quiz'),
  'it_inner_groups_permission':('Teilgruppen','Link label - Inner groups which participants can solve quiz'),
  'it_user_permission':('Personen','Link label - Users who have permission to solve quiz'),
  'it_add_user_permission':('Hinzufgen','Button label -  add user permission'),
  'it_add_group_permission':('Hinzufgen','Button label - add group permission'),
  'it_question':('Frage','Table header - Question in page creating quiz'),
  'it_answer':('Antwort','Table header - '),
  'it_type':('Type','Table header - Type'),
  'it_deletion':('Zum Lschen','Tabel header - select for deleting'),
  'it_points':('Punkte','Table header - maximum points for this questions'),
  'it_change':('ndern','Table header - Change exercise in test'),
  'it_delete_exercise':('Lschen','Button label - Delete'),
  'it_make_public':('Publiziere','Link label - Make test available for students'),
  'it_hide':('Verstecke','Link label - Hide quiz'),
  'it_add_exercise':('Frage hinzufgen','Link label - Add question'),
  'it_results_from_users':('Lsungen von Teilnehmern','Link label - list of students who and how solved test'),
  'it_import_from_hotpotatoes':('Importieren aus HotPotatoes','Link label - Import as text file'),
  'it_export_to_web_ct':('Exportieren nach WebCT','Link label - Export to text file'),
  'it_solving_test':('Test %s lsen','Header - solving the quiz'),
  'it_save_solved_test':('Antworten speichern','Button label - Save quiz answers'),
  'it_answers_saved':('Antworten gespeichert','Message - Quiz answers saved'),
  'it_answer_instance':('Lsung no.','Heading'),
  'it_test_answers':('Antworten','Header - List of submissions'),
  'it_hdr_tests':('Tests','Breadcrumbs'),  #16.02
  'it_problem_in_finding_users':('Username ist nicht aufzufinden','Message'),
  'it_delete_permission':('Lschen','Button label - Delete permissions'),
  'it_an_question':('Frage','Table header - Question in user answer list page'),
  'it_an_user_answer':('Gegebene Antworten','Table header - '),
  'it_an_answer_commenting_table':('Kommentare hinzufgen','Link label'),  #16.02
  'it_an_teacher_answer':('Lehrerantwort','Table header - Correct answer from teacher'),
  'it_an_result':('Richtig','Table header - Checked if answer right'),
  'it_an_points':('Testergebnis','Table header - Score'),
  'it_an_comment':('Kommentar','Table header - comment from teacher'),
  'it_anc_question':('Frage','Table header - Question in commenting answers page'),
  'it_anc_user_answer':('Schlerantworten','Table header - Student response'),
  'it_anc_teacher_answer':('Lehrerantwort','Table header - Result suggested by teacher'),
  'it_anc_result':('Richtig','Table header - Is answer correct'),
  'it_anc_automatic_points':('Computerberechnetes Testergebnis','Table header - Automatically calculated total score'),
  'it_anc_teacher_points':('Zusatzpunkte des Lehrers','Table header - Points added by teacher'),
  'it_anc_nominal_points':('Maximale Punkte', 'Table header - How many points for the right answer'),
  'it_anc_teachers_comment':('Kommentar','Table header - Comment from teacher'),
  'it_anc_point_reading':('Kalkulation der Punkte','Table header - Does teacher add points from this exercise to quiz total score'),
  'it_anc_comment_to_whole_answer':('Gesamtbewertung','Header - Teachers comment to the students quiz result in general'),
  'it_anc_save':('Speichern','Button label - Save points and comments'),
  'it_no_percent_calculating':('Keine Prozentkalkulation mglich','Message - Percentage not calculated, because no nominal points in this test.'),
  'it_test_answers':('Antworten zum Test %s','List heading - Quiz submissions'),
  'it_tests':('Tests','Breadcrumbs - Quizzes'),
  'it_answers':('Antworten','Breadcrumbs - Responses'),

  'it_open_test':('Test publizieren','Link label - make quiz public for all students'), #29.03
  'it_opened_for_all':('Zugang fr alle','message in the list of quizzes'), #29.03
  'it_add_group_permission':('Hinzufgen','link label - give quiz solving permission to a group'), #29.03
  'it_add_personal_permission':('Hinzufgen','link label - give quiz solving permission to a person'), #29.03
  'it_delete_permission':('Entfernen','Button label - remove permission'),
  'it_no_users_without_permission':('Test zugnglich fr Alle','message'), #29.03
  'it_no_groups_without_permission':('Test zugnglich fr alle Gruppen','message'), #29.03

 #kasutajateTulemused - testitulemuste kuvamise leht
  'it_show_comments':('Kommentare zeigen','Link label'), #05.04 Mart
  'it_hide_comments':('Kommentare verstecken','Link label'), #05.04 Mart

 #lubadeViited 
  'it_timelimit':('Zeitlimite','Link label'), #05.04 Mart 

 #koigiLuba - testi piirangute seadmise vorm
  'it_start_time':('Anfang','Table column heading'), #05.04 Mart
  'it_end_time':('Ende','Table column heading'), #05.04 Mart
  'it_repeat':('Wiederholungen','Table column heading'), #05.04 Mart
  'it_unlimited':('Unbegrenzt','Table column heading'), #05.04 Mart
  'it_save':('Speichern','Button label'),  #05.04 Mart

  
  #testihaldus.dtml #16.02 - by Mart
  'it_add_test':('Test hinzufgen','Menu item - Add quiz'),
  'it_tests_bread':('Tests','Breadcrumb'),
  'it_test_select':('Auswhlen','Table column heading'),
  'it_test_id':('ID',''),
  'it_test_name':('Testname',''),
  'it_test_ready_to_solve':('Test ausfhrbar','Table column heading - is it available for students'),
  'it_test_rename':('Umbenennen','Button label'),
  'it_test_delete':('Lschen','Button label'),
  'it_test_export':('Exportieren','Button label'),
  'it_test_import':('Importieren','Button label'),
  'it_test_user_answers':('Lsungen',''),

  'it_test_randomized':('Zufallsanordnung','Table column heading'), #05.04
  'it_test_submissions':('Lsungen','Table column heading'), #05.04
  'it_test_randomize':('Zufallsanordnung','Button label'), #05.04

  '':('',''),

                      
                        
  #YlAlus.py
  'it_incorrect_point_count':('Anzahl der Punkte fehlerhaft','Message - Invalid quiz score'),
  'it_ex_question':('Frage','Heading before question field'),
  'it_ex_save':('Speichern','Button label - Save question'),
  '':('',''),
  #'it_no_point_calculating':('Punktensumme nicht kalkuliert','Total score is not calculated for this quiz'),
  'it_link_url':('Link URL','Heading before URL field'),
  'it_link_text':('Link Text','Heading before URL title field'),
  'it_delete_picture':('Lschen','Heading of checkbox - select picture for deleting'),
  'it_no_automatic_point_calculating':('kein computerberechnetes Testergebnis','No automatic calculation of score'),
  'it_nominal_points':('Hchstanzahl der Punkte','Heading before MaxPoints field - The highest possible score'),
  'it_no_link_address':('Fehlende Adresse','Message - Address missing'),
  'it_incorrect_URL':('URL fehlerhaft','Message - Invalid URL'),
  'it_describing_text':('Beschreibung', 'Form item label'), #29.03

  'it_picture':('das Bild','Form item label'), #05.04 Mart
  

  #YlTyybid.py
 # 'it_incorrect_answer':('Antwort falsch',''),
  'it_no_saved_answer':('Antwort nicht gespeichert','Message - Answer not saved'),
  'it_no_answer_text':('Antwort fehlt','Message - Answer text missing'),
  'it_no_choices':('Varianten fehlen','Message - Missing answer choices'),
  'it_no_answer':('Richtige Lsung fehlt','Message - Missing correct answer'),
  'it_no_choices_in_viewing':('Varianten fehlen','Message - Missing answer choices'),
  'it_problem_with_data':('Datenfehler','Message - Problem with question data'),
  'it_one_answer':('Richtige Antwort','Header - Correct answer'),
  'it_correct_answers':('Richtige Antworten','Header - Correct answers'),

  'it_check_exercise':('Ja/Nein Aufgabe','Question type - binary, checkbox'), #16.02 lesannete nimetused
  'it_text_answer_exercise':('Textaufgabe','Question type - paragraph'),
  'it_one_answer':('Kurzantwort','Question type - short answer'),
  'it_multiple_choice_exercise':('Mehrfach-Wahl-Aufgabe','Question type - mark all correct options'),
  'it_one_answer_exercise':('Zweifach-Wahl-Aufgabe','Question type - Multiple choice'),

  'it_number_space_exercise':('Numerische Aufgabe','Question type - numerical'), #29.03 
  'it_percent_excercise':('Prozentaufgabe','Question type - percent calculation'), #29.03
  'it_matching_exercise':('bereinstimmungsaufgabe','Question type - matching'), #29.03

  #Multiple answers #05.08
  'it_ov_variant':('Varianten','Table heading'),
  'it_ov_explanation':('Erluterung','Table heading'),
  'it_ov_correct':('Richtig','Table heading'),
  

  
  #Multiple choice #05.08
  'it_yv_variants':('Varianten','Table heading'),
  'it_yv_explanation':('Erluterung','Table heading'),
  'it_yv_correct':('Richtig','Table heading'),

  '':('',''),
  #Numerical item settings, #29.03
  'it_av_min_correct':('Minimal','Table heading: lower limit of accepted range'),  
  'it_av_centre_correct':('Genau','Table heading: exact answer'), 
  'it_av_max_correct':('Maximal','Table heading: upper limit of accepted range'), 
  'it_av_checking_type':('Kalkulation','Question before menu options'), 
  'it_av_space':('Bereich','Menu option. Maximum score if answer falls anywhere within the range'),
  'it_av_linear':('Linear','Menu option. Score given depends on distance from exact answer.'),

  #Percent calculation item settings, #29.03
  'it_pr_solvents':('Wasser; destilliertes Wasser','List of default solvents, separated with semicolon'), 
  'it_pr_soluble':('Salz; Zucker','List of default solubles, separated with semicolon'),
  'it_pr_term_solution_percent':('Strke der Lsung','Text, used in several contexts: Strength of solution'),
  'it_pr_term_solvent_amount':('Menge des Lsungsmittels','Text, used in several contexts: amount of solvent'),
  'it_pr_term_soluble_amount':('Stoffmenge','Text, used in several contexts: amount of soluble'),
  'it_pr_term_soluble_to_solvent':('Stoff/Lsung','Text, used in several contexts'),
  'it_pr_term_asking_answer':('Ergebnis','Comment to solver'),
  'it_pr_soluble_amount_space':('Akzeptierbarer Bereich von Stoffmenge','Label on the page of entering the question: range'),
  'it_pr_solvent_amount_space':('Akzeptierbarer Bereich von Lsungsmittelsmenge, Messeinheit','Label: range'),
  'it_pr_soluble_names':('Name des Stoffes, Einheit','Label: soluble name and measurement unit'),
  'it_pr_solvent_names':('Name des Lsungmittels, Einheit','Label: solvent name and measurement unit'),
  'it_pr_answer_exactitude_percent':('Genauigkeit der Antwort','Label on the page of entering the question'),
  'it_pr_answer_type':('Art der Antwort','Label on the page of entering the question: searchable'),
  'it_pr_checking_type':('Kalkulation','Question before menu options'),
  'it_pr_space':('Bereich','Menu option: Maximum score if answer falls anywhere within the range'),
  'it_pr_linear':('Linear','Menu option: Score given depends on distance from exact answer'),
  '':('',''),
  '':('',''),

  #Matching #05.08
  'it_mt_left':('Linke Spalte','Table heading'),
  'it_mt_right':('Rechte Spalte','Table heading'),

  '':('',''),

  #YlVahendus.py
  'it_send_text':('Importieren','Button label - Import quiz as text'),
  'it_send_file':('Importieren','Button label - Import quiz as textfile'),

  'it_choosing_exercise_type':('Typ der Aufgabe whlen','Heading - Select question type'), #16.02

  'it_check_exercise_default_question':('Text der Aufgabe','Default question text for binary question'),     #16.02 jj
  'it_text_answer_exercise_default_question':('Text der Aufgabe','Default question text for paragraph question'),
  'it_one_answer_default_question':('Text der Aufgabe','Default question text for short answer question'),
  'it_multiple_choice_exercise_default_question':('Text der Aufgabe','Default question text for mark-all question'),
  'it_one_answer_exercise_default_question':('Text der Aufgabe','Default question text for multiple choice question'),

  'it_percent_exercise_default_question':('Fehlende Komponente finden','Default percent question heading'), #29.03
  'it_matching_exercise_default_question':('Passende Paare finden','Default matching question heading'), #29.03
  'it_number_space_exercise_default_question':('Text der Aufgabe','Default numerical question heading'), #29.03

  '':('',''),
}

# All vocabularies combined
vocabulary = {'common': common,
              'kb': kb,
              'webtop': webtop,
              'usermgmnt': usermgmnt,
              'coursemgmnt': coursemgmnt,
              'jam': jam,
              'ivacommon': ivacommon,
              'ivatests': ivatests,
              }
              
#print vocabulary['ivatests']['it_send_file']


#EOF

